import es
import random
import popuplib
import vecmath
import playerlib
import gamethread
import os
import pickle
import dmg
import math
import time
import psyco
psyco.full()

info = es.AddonInfo() 
info.name = 'wcs2' 
info.version = '1.0 beta 1' 
info.url = 'www.ninjaserve.org' 
info.basename = 'wcs2' 
info.author = '7355608' 

# ultimates
wc_ult_delay = 10.0
wc_ult_cooldown = 35.0

# shopmenu items
wc_glove_timer = 10.0
wc_glove_orc_damage = 0
wc_nadelist = {}
wc_headshots = {}
wc_wardlist = {}
wc_bombsites = {}

# xp
wc_min_players = 2
wc_xp_radius = 750
wc_xp = {'bomb_planted': {'ammount': 50, 'reason': 'planting the bomb'},'bomb_exploded': {'ammount': 25, 'reason': 'bomb exploding'},'bomb_defused':{'ammount': 50, 'reason': 'defusing the bomb'},'bomb_defused_team':{'ammount': 25, 'reason': 'your team defusing the bomb'},'hostage_rescued': {'ammount': 25, 'reason': 'rescuing a hostage'},'hostage_rescued_all': {'ammount': 25, 'reason': 'rescueing all the hostages'},'player_frag': {'ammount': 25, 'reason': 'killing a player'},'player_knife': {'ammount': 75, 'reason': 'knifing a player'},'player_skillfrag': {'ammount': 25, 'reason': 'killing a player'},'headshot': {'ammount': 35, 'reason': 'making a headshot'}}
wc_max_skill_lvl = 3
wc_max_race_lvl = 10
wc_lvl_exponent = 2.093
wc_lvl_mod = 100
wc_max_lvl = 10
wc_ult_level = 6
wc_max_ult_lvl = 1
#items per menu
wc_item_menus = 2
wc_max_items_each = 1

# global constants
wc_spawnhp = 0
wc_basehp = 10240
wc_blinkdistance = 500
wc_skill_deaths = 0
wc_weaponlist = 'smokegrenade flashbang m3 xm1014 hegrenade glock usp p228 deagle elite fiveseven awp g3sg1 sg550 galil ak47 scout sg552 famas m4a1 aug mac10 tmp mp5navy ump45 p90 m249 knife'
wc_pistol = ['glock', 'usp', 'p228', 'deagle', 'elite', 'fiveseven']
wc_primary = ['awp', 'g3sg1', 'sg550', 'galil', 'ak47', 'scout', 'sg552', 'famas', 'm4a1', 'aug', 'm3', 'xm1014', 'mac10', 'tmp', 'mp5navy', 'ump45', 'p90', 'm249']
wc_reflecting = ['thorns_aura','spiked_carapace']
wc_pheonix_t = 0
wc_pheonix_ct = 0
wc_regen_cycle = 5
wc_regen_max = 5
# global lists

# Temporary DB
wc_users = {}
# Master DB
wc_skills = None

# initializing important globals
wc_timers = {}
wc_tspawn = {}
wc_ctspawn = {}
wc_moles = {}
wc_weapontracking = {}
wc_max_skills = 3
wc_ult_enabled = 0
wc_stopcheck = es.ServerVar('wc_tempid','0')

wc_spawnlist = {}
wc_racelist = []

#races
wc_races_list = {}
wc_races_list2 = {}
#items lists
wc_items_list = {1:{'Menu': []},2:{'Menu': []}}

""" database will be:
	wc_skills {
		'steamid' {
			'racename'		'skill1...skilln.level.xp'
			   x number of races
			'lastrace'		'Undead Scourge'
			'lastplayed'	'timestamp'
		}
	}
"""
"""
	Race.items() = 
	ln      = Long Name
	sn      = Short Name
	ult_viewtarget = does ultimate require a target in crosshairs
	ult_target = does ultimate require a target
	ult_coord = does ultimate require co-ordinates
	ult_skill = Activatable Ultimate Skill
	uid     = Player Userid
	steamid = Player Steamid
	level   = Race Level (0 to wc_max_lvl)
	skill[n]  = (0 to wc_max_skill_lvl); where n = 1 to wc_max_skills 
	ult     = Ultimate (0 to wc_max_ult_lvl)
"""
class Race(object):
	"Races Class used for Race functions"
	
	def __init__(self, wc_userid, wc_race='None'):
		self.uid = wc_userid
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		if wc_race == "None":
			if wc_steamid == 'BOT':
				wc_race = 'Undead Scourge'
			else:
				wc_race = wc_users[wc_steamid]['race']
		self.ln = wc_race
		self.sn = wc_race
		self.race = wc_race
		self.ult_viewtarget = 0
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 0
		self.skill = {}
		if wc_steamid != 'BOT':
			self.level = wc_users[wc_steamid][wc_race]['level']
			for wc_tmp in wc_users[wc_steamid][wc_race]:
				self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
				
	def refresh_skills(self):
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[self.steamid][self.race][wc_tmp]
	
	#class skill handling
	def offensive(self,wc_eventvars,wc_kill):
		return 0
		
	def defensive(self,wc_eventvars):
		return 0
		
	def spawn(self):
		return 0
	
	def victim_death(self,wc_eventvars):
		return 0
		
	def attacker_death(self,wc_eventvars):
		return 0
	
	def ability(self):
		return 0
		
	def ultimate(self,wc_victim=0):
		return 0
		
	def grenade_toss(self,wc_eventvars):
		return 0
	
class Undead(Race):
	"Undead Skills"
	def __init__(self, wc_userid, wc_race='Undead Scourge'):
		wc_race = 'Undead Scourge'
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = wc_userid
		self.ln = wc_race
		self.sn = 'Undead'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 0
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 1
		self.skills = {"vamp_aura": {1:0.10, 2:0.20, 3:0.30},"unholy_aura": {1:0.08,2:0.17,3:0.21},"levitation": {1:0.80,2:0.60,3:0.40},"suicide_explosion": {1:50}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
	
	def vamp_aura(self,wc_victim,wc_damage,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['vamp_aura']:
				return 0
			wc_lvl = self.skill['vamp_aura']
		wc_dmg = float(self.skills['vamp_aura'][wc_lvl]) * float(wc_damage)
		wc_tmp = playerlib.getPlayer(self.uid)
		if wc_users[self.steamid]['maxhp'] > wc_tmp.get('health'):
			if wc_tmp.get('health') + int(wc_dmg) > wc_users[self.steamid]['maxhp']:
				wc_tmp.set('health',wc_users[self.steamid]['maxhp'])
			else:
				wc_tmp.set('health',wc_tmp.get('health') + int(wc_dmg))
		
	def unholy_aura(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['unholy_aura']:
				return 0
			wc_lvl = float(self.skill['unholy_aura'])
		wc_tmp = playerlib.getPlayer(self.uid)
		if wc_lvl < 0:
			wc_tmp.set('speed',1.0)
			wc_users[self.steamid]['speed'] = 1.0
		else:
			wc_users[self.steamid]['speed'] = wc_tmp.get('speed') + self.skills['unholy_aura'][wc_lvl]
			wc_tmp.set('speed',wc_users[self.steamid]['speed'])
		
	def levitation(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['levitation']:
				return 0
			wc_lvl = int(self.skill['levitation'])
		if wc_lvl > 0:
			es.server.queuecmd('es_fire %s !self addoutput \"gravity %f\"' % (self.uid, self.skills['levitation'][wc_lvl]))
			wc_users[self.steamid]['gravity'] = self.skills['levitation'][wc_lvl]
		else:
			es.server.queuecmd('es_fire ' + str(self.uid) + ' !self addoutput \"gravity 1.0\"')
			wc_users[self.steamid]['gravity'] = 1.0
		
	def suicide_explosion(self,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['suicide_explosion']:
				return 0
		wc_soundrand = ['weapons\explode3.wav','weapons\explode4.wav','weapons\explode5.wav']
		random.shuffle(wc_soundrand)
		wc_expsound = wc_soundrand.pop()
		#//set explosion variables 
		wc_tmpme = playerlib.getPlayer(self.uid)
		wc_dead = int(wc_tmpme.get('isdead'))
		wc_formatexplosion = 'explosion_' + str(random.randint(1,9999))
		wc_tempexpteam = es.getplayerteam(self.uid)
		wc_owner = es.getplayerhandle(self.uid)
		es.server.cmd('es_give ' + str(self.uid) + ' env_explosion')
		wc_expindex = int(es.getString('eventscripts_lastgive'))
		es.server.queuecmd('est_setentname ' + str(wc_expindex) + ' ' + wc_formatexplosion)
		wc_expvec = vecmath.vector(es.getplayerlocation(self.uid))
		if wc_dead == 0:
			wc_expvec['z'] += 25
		else:
			wc_expvec['z'] -= 40
		es.server.queuecmd('es_fire ' + str(self.uid) + ' ' + wc_formatexplosion + ' addoutput \"origin ' + str(wc_expvec['x']) + ' ' + str(wc_expvec['y']) + ' ' + str(wc_expvec['z']) + '\"') 
		wc_explosions = es.createentitylist('env_explosion') 
		for wc_tmp in wc_explosions:
			es.setindexprop(wc_tmp,"CBaseEntity.m_iTeamNum",wc_tempexpteam)
			es.setindexprop(wc_tmp,"CBaseEntity.m_hOwnerEntity",wc_owner)
		#//Power 
		if wc_dead == 0:
			es.server.queuecmd('es_fire '+ str(self.uid) + ' ' + wc_formatexplosion + ' addoutput \"imagnitude 300\"')
		else:
			es.server.queuecmd('es_fire '+ str(self.uid) + ' ' + wc_formatexplosion + ' addoutput \"imagnitude 150\"')
		#//Range 
		wc_radius = '250'
		es.server.queuecmd('es_fire ' + str(self.uid) + ' ' + wc_formatexplosion + ' addoutput \"iradiusoverride ' + str(wc_radius) + '\"')
		es.emitsound('entity',wc_expindex,wc_expsound,1,0.60)
		#// This is it... time to explode! 
		wc_startvec = es.createvectorstring(wc_expvec['x'],wc_expvec['y'],wc_expvec['z'])
		es.server.queuecmd('est_Effect_08 #a!b 0.0 sprites/laser.vmt ' + wc_startvec + ' ' + str(wc_radius) + ' 50 10 0.5 50 25 0 0 255 0 255 300 0')
		es.server.queuecmd('est_Effect_08 #a!b 0.5 sprites/laser.vmt ' + wc_startvec + ' 50 ' + str(wc_radius) + ' 10 0.5 50 25 0 0 255 0 255 150 0')
		es.server.queuecmd('es_fire ' + str(self.uid) + ' ' + wc_formatexplosion + ' explode')
		es.server.queuecmd('es_fire ' + str(self.uid) + ' ' + wc_formatexplosion + ' kill')
		#es_keysetvalue wc_users server_var(wc_steamid) enabled 0
		es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 0.5 0 0 255 0 255')
		if wc_dead == 0:
			es.sexec(self.uid,'kill')
		#wc_tmp.hurt(int(self.uid),'suicide_explosion',31337)
		
	def offensive(self,wc_eventvars,wc_kill):
		self.vamp_aura(wc_eventvars['userid'],wc_eventvars['dmg_health'])
	
	def victim_death(self,wc_eventvars):
		if wc_ult_enabled > 0 and wc_users[self.steamid]['ultimate'] > 0:
			wc_expvec = vecmath.vector(es.getplayerlocation(self.uid))
			wc_expvec['z'] -= 40
			wc_blinkcheck = check_blinkcoord(self.uid, wc_expvec)
			if wc_blinkcheck == 0:
				self.suicide_explosion()
		
	def ultimate(self,victim=0):
		self.suicide_explosion()
	
	def spawn(self):
		global wc_users
		self.levitation()
		self.unholy_aura()
		if self.skill['suicide_explosion']:
			wc_users[self.steamid]['ultimate'] = 1

# This is the list of skills / ultimates / abilities / instance call
wc_races_list['Undead Scourge'] = {'instance': Undead, 'skills': {"vamp_aura": 'skill',"unholy_aura": 'skill',"levitation": 'skill',"suicide_explosion": 'ult'}}
# The oder of this, is how the menu displays
wc_races_list['Undead Scourge']['display'] = ['Vampiric Auara','Unholy Aura','Levitation','Suicide Explosion']
# The order of this must match the other list, this is the return values from the menu
wc_races_list['Undead Scourge']['return'] = ['vamp_aura','unholy_aura','levitation','suicide_explosion']
# This is for the SkillsInfo
wc_races_list['Undead Scourge']['info'] = ['Gain HP Based on Partial Damage Dealt','Increase Your Movement Speed','Gives You Low Gravity','Explode Killing Enemies, Stronger When Activated Manually']
# This adds to the race menu list
wc_racelist.append('Undead Scourge')

class Human(Race):	
	"Human Skills"
	def __init__(self, wc_userid, wc_race='Human Alliance'):
		global wc_users
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = wc_userid
		wc_race = 'Human Alliance'
		self.ln = wc_race
		self.sn = 'Human'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 0
		self.ult_target = 0
		self.ult_coord = 1
		self.ult_skill = 0
		self.skills = {"bash": {1:11,2:22,3:33}, "invisibility": {1:200,2:175,3:135}, "devotion_aura": {1:15,2:30,3:45}, "teleport": {1:1}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def invisibility(self,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['invisibility']:
				return 0
			wc_lvl = self.skill['invisibility']
		if wc_lvl > 0:
			es.server.queuecmd('es_fire ' + str(self.uid) + ' !self addoutput \"rendermode 1\"')
			es.server.queuecmd('es_fire ' + str(self.uid) + ' !self alpha ' + str(self.skills['invisibility'][wc_lvl]))
		elif wc_lvl < 0:
			es.server.queuecmd('es_fire ' + str(self.uid) + ' !self addoutput \"rendermode 1\"')
			es.server.queuecmd('es_fire ' + str(self.uid) + ' !self alpha 255')
		
	def devotion_aura(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['devotion_aura']:
				return 0
			wc_lvl = self.skill['devotion_aura']
		wc_tmp = playerlib.getPlayer(self.uid)
		wc_tmphp = wc_tmp.get('health') + self.skills['devotion_aura'][wc_lvl]
		gamethread.delayed(0.3,wc_tmp.set,('health',wc_tmphp))
		wc_users[self.steamid]['maxhp'] += self.skills['devotion_aura'][wc_lvl]

	def bash(self,wc_victim,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['bash']:
				return 0
			wc_lvl = self.skill['bash']
		wc_rand = random.randint(1,100)
		if wc_rand <= self.skills['bash'][wc_lvl]:
			wc_tmp = playerlib.getPlayer(wc_victim)
			wc_tmp.set('freeze',1)
			#es.msg('#green','Froze player: ' + es.getplayername(wc_victim))
			gamethread.delayed(0.75,wc_tmp.set,('freeze',0))
	
	def teleport(self,wc_viewcoord):
		wc_player_coord = vecmath.vector(es.getplayerlocation(self.uid))
		wc_tmpvec = wc_viewcoord - wc_player_coord
		wc_tmplen = vecmath.length(wc_tmpvec)
		if wc_tmplen > 50.0:
			wc_tmplen -= 50.0
			wc_tmp = vecmath.setlength(wc_tmpvec,wc_tmplen)
			wc_teleportvec = wc_player_coord + wc_tmp
			wc_blinkcheck = check_blinkcoord(self.uid,wc_teleportvec)
			if not wc_blinkcheck:
				wc_dir = es.getplayerprop(self.uid,'CBasePlayer.baseclass.baseclass.baseclass.baseclass.baseclass.m_angRotation')
				wc_startvec = es.createvectorstring(wc_player_coord['x'],wc_player_coord['y'],wc_player_coord['z'])
				wc_startvec2 = es.createvectorstring(wc_player_coord['x'],wc_player_coord['y'],wc_player_coord['z'] + 200.0)
				wc_endvec = es.createvectorstring(wc_teleportvec['x'],wc_teleportvec['y'],wc_teleportvec['z'])
				wc_endvec2 = es.createvectorstring(wc_teleportvec['x'],wc_teleportvec['y'],wc_teleportvec['z'] + 200.0)
				wc_tmpdir = es.splitvectorstring(wc_dir)
				wc_newdir = []
				for wc_tdir in wc_tmpdir:
					wc_newdir.append(wc_tdir * -1)
				wc_enddir = es.createvectorstring(wc_newdir[0],wc_newdir[1],wc_newdir[2])
				es.server.queuecmd('est_effect_26 #a!b 0.0 ' + wc_startvec + ' ' + wc_dir + ' 10 1')
				es.server.queuecmd('est_Effect_06 #a!b 0.0 sprites/plasmabeam.vmt ' + wc_startvec + ' ' + wc_startvec2 + ' 15 1 50 75 10 1 255 255 255 150 50')
				es.setpos(self.uid,wc_teleportvec['x'],wc_teleportvec['y'],wc_teleportvec['z'])
				es.server.queuecmd('est_effect_26 #a!b 0.0 ' + wc_endvec + ' ' + wc_enddir + ' 10 1')
				es.server.queuecmd('est_Effect_06 #a!b 0.0 sprites/plasmabeam.vmt ' + wc_endvec2 + ' ' + wc_endvec + ' 15 1 50 75 10 1 255 255 255 150 50')
				es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 0.5 0 255 255 255 126')
				gamethread.delayed(0.5,self.check_teleport,wc_player_coord)
			else:
				es.server.queuecmd('est_csay ' + str(self.uid) + ' Teleport Blocked')
		else:
			gamethread.cancelDelayed('ult' + str(self.uid))
			gamethread.delayedname(0.1,'ult' + str(self.uid),wc_enable_ult,self.uid)
			es.server.queuecmd('est_csay ' + str(self.uid) + ' Teleport distance too short')
				
	def check_teleport(self,wc_oldpos):
		if int(es.getplayerprop(self.uid,"CBasePlayer.localdata.m_hGroundEntity")) == -1:
			es.server.queuecmd('est_csay ' + str(self.uid) + ' Bad Teleport')
			es.setpos(self.uid,wc_oldpos['x'],wc_oldpos['y'],wc_oldpos['z'])
			gamethread.cancelDelayed('ult' + str(self.uid))
			gamethread.delayedname(3.0,'ult' + str(self.uid),wc_enable_ult,self.uid)
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.bash(int(wc_eventvars['userid']))
		
	def ultimate(self,wc_victim=0):
		self.teleport(wc_victim)
	
	def spawn(self):
		global wc_users
		self.invisibility()
		self.devotion_aura()
		if self.skill['teleport']:
			wc_users[self.steamid]['ultimate'] = 1
	
wc_races_list['Human Alliance'] = {'instance':Human, 'skills': {"bash": 'skill', "invisibility": 'skill', "devotion_aura": 'skill', "teleport": 'ult'}} 
wc_races_list['Human Alliance']['display'] = ['Invisibility','Devotion Aura','Bash','Teleport']
wc_races_list['Human Alliance']['return'] = ['invisibility','devotion_aura','bash','teleport']
wc_races_list['Human Alliance']['info'] = ['Partial Invisibility','Increases Your Max HP','Chance to Freeze Enemies for 1 sec','Teleport to Where You Look']
wc_racelist.append('Human Alliance')

class Orc(Race):
	"Orc Skills"
	def __init__(self, wc_userid, wc_race='Orcish Horde'):
		wc_race = 'Orcish Horde'
		wc_steamid = es.getplayersteamid(wc_userid)
		self.uid = int(wc_userid)
		self.steamid = wc_steamid
		self.ln = wc_race
		self.sn = 'Orc'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 1
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 0
		self.skills = {"critical_strike": {1:15,2:20,3:25}, "critical_grenade": {1:1,2:1.5,3:2}, "equipment_reincarnation": {1:33,2:50,3:100}, "chain_lightning": {1:80}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def critical_strike(self,wc_victim,wc_damage,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['critical_strike']:
				return 0
			wc_lvl = self.skill['critical_strike']
		wc_orcrand = random.randint(1,100)
		if wc_orcrand <= self.skills['critical_strike'][wc_lvl]:
			wc_tmp = dmg.get(self.uid)
			wc_tmp.hurt(wc_victim,int(wc_damage),2,"critical_strike")
			wc_vec = vecmath.vector(es.getplayerlocation(wc_victim))
			wc_vec2 = vecmath.vector(es.getplayerlocation(wc_victim))
			wc_vec['z'] += 60.0
			wc_vec2['z'] += 65.0
			wc_vecstr = es.createvectorstring(wc_vec['x'],wc_vec['y'],wc_vec['z'])
			wc_vecstr2 = es.createvectorstring(wc_vec2['x'],wc_vec2['y'],wc_vec2['z'])
			es.server.queuecmd('est_effect_19 #a!b 0.0 ' + wc_vecstr + ' ' + wc_vecstr2 + ' 0')
			
	def critical_grenade(self,wc_victim,wc_damage,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['critical_grenade']:
				return 0
			wc_lvl = self.skill['critical_grenade']
		if wc_glove_orc_damage == 0 and check_hasitem(self.uid,'Flaming Gloves of Warmth') != 0:
			return 0
		tmp_dmg = int(int(wc_damage) * self.skills['critical_grenade'][wc_lvl])
		wc_tmp = dmg.get(self.uid)
		wc_tmp.hurt(wc_victim,tmp_dmg,8,"critical_grenade")
		#es.tell(self.uid,'#multi','#greenOriginal Dmg: #lightgreen' + str(wc_damage) + ' #greenwith #lightgreen' + str(tmp_dmg) + ' #greendamage.')
			
	def equipment_reincarnation(self,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['equipment_reincarnation']:
				return 0
			wc_lvl = self.skill['equipment_reincarnation']
		if wc_lvl == 100:
			wc_orctmp = 100
		else:
			wc_orctmp = self.skills['equipment_reincarnation'][wc_lvl]
		if random.randint(1,100) <= wc_orctmp:
			if wc_weapontracking.has_key(str(self.uid)):
				if wc_weapontracking[str(self.uid)]['pistol'] != None:
					es.server.queuecmd('est_RemoveWeapon ' + str(self.uid) + ' 2')
					es.server.queuecmd('es_give ' + str(self.uid) + ' ' + wc_weapontracking[str(self.uid)]['pistol'])
					#es.tell(self.uid,'#green','gave pistol: ' + wc_weapontracking[str(self.uid)]['pistol'])
				if wc_weapontracking[str(self.uid)]['primary'] != None:
					es.server.queuecmd('est_RemoveWeapon ' + str(self.uid) + ' 1')
					es.server.queuecmd('es_give ' + str(self.uid) + ' ' + wc_weapontracking[str(self.uid)]['primary'])
					#es.tell(self.uid,'#green','gave primary: ' + wc_weapontracking[str(self.uid)]['primary'])
				wc_tmp = playerlib.getPlayer(self.uid)
				wc_tmp.set('armor',100)
			
	def chain_lightning(self,wc_victim):
		wc_attacker = dmg.get(self.uid)
		wc_attacker.hurt(wc_victim,50,1,"chain_lightning")
		wc_tmpvector = vecmath.vector(es.getplayerlocation(wc_victim))
		wc_tmpvector2 = vecmath.vector(es.getplayerlocation(self.uid))
		wc_tmpvector2['z'] += 45.0
		wc_team = int(es.getplayerteam(wc_victim))
		wc_tmplist = near_coord(wc_team,250.0,wc_tmpvector)
		wc_tmpvector['z'] += 45.0
		wc_startvec = es.createvectorstring(wc_tmpvector2['x'],wc_tmpvector2['y'],wc_tmpvector2['z'])
		wc_endvec = es.createvectorstring(wc_tmpvector['x'],wc_tmpvector['y'],wc_tmpvector['z'])
		es.server.queuecmd('est_effect_06 #a!b 0.0 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 1 10 10 10 1.5 255 0 0 255 200')
		wc_startvec = wc_endvec
		if wc_tmplist != 0:
			for wc_tmp in wc_tmplist:
				if not check_blink(wc_tmp) and int(wc_tmp) != int(wc_victim):
					wc_tmpvector = vecmath.vector(es.getplayerlocation(wc_tmp))
					wc_tmpvector['z'] += 45.0
					wc_endvec = es.createvectorstring(wc_tmpvector['x'],wc_tmpvector['y'],wc_tmpvector['z'])
					es.server.queuecmd('est_effect_06 #a!b 0.1 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 1 10 10 10 1.5 255 0 0 255 150')
					wc_attacker.hurt(wc_tmp,25,1,"chain_lightning")
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			if wc_eventvars['weapon'] != 'hegrenade':
				self.critical_strike(wc_eventvars['userid'],float(wc_eventvars['dmg_health']))
			else:
				self.critical_grenade(wc_eventvars['userid'],float(wc_eventvars['dmg_health']))
		
	def ultimate(self,wc_victim=0):
		if int(wc_victim) > 0:
			self.chain_lightning(int(wc_victim))
	
	def spawn(self):
		global wc_users
		self.equipment_reincarnation()
		if self.skill['chain_lightning']:
			wc_users[self.steamid]['ultimate'] = 1
		
	def grenade_toss(self,wc_eventvars):
		if wc_glove_orc_damage == 0 and check_hasitem(self.uid,'Flaming Gloves of Warmth') != 0:
			return 0
		if self.skill['critical_grenade']:
			gamethread.delayed(0.15,self.nadetrail,wc_eventvars['userid'])
		
	def nadetrail(self,userid):
		nadelist = es.createentitylist('hegrenade_projectile')
		for tmp in nadelist:
			if int(nadelist[tmp]['CBaseCSGrenadeProjectile.baseclass.m_hThrower']) == int(es.getplayerhandle(userid)):
				es.server.queuecmd('est_effect_04 #a!b 0.0 sprites/laser.vmt ' + str(tmp) + ' 2.0 40 40 0.5 255 0 0 200')
		
wc_races_list['Orcish Horde'] = {'instance':Orc, 'skills': {"critical_strike": 'skill', "critical_grenade": 'skill', "equipment_reincarnation": 'skill', "chain_lightning": 'ult'}}
wc_races_list['Orcish Horde']['display'] = ['Critical Strike','Critical Grenade','Equipment Re-Incarnation','Chain Lightning']
wc_races_list['Orcish Horde']['return'] = ['critical_strike','critical_grenade','equipment_reincarnation','chain_lightning']
wc_races_list['Orcish Horde']['info'] = ['Chance to Deal Double Damage','All Grenades Deal Multiple Damage','Chance to Regenerate Previous Weapons, Gives Full Kevlar','Deals Damage to Victim, Plus Surrounding Enemies']
wc_racelist.append('Orcish Horde')

class NElf(Race):	
	"Elf Skills"
	def __init__(self, wc_userid, wc_race='Human Alliance'):
		global wc_users
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = int(wc_userid)
		wc_race = 'Night Elf'
		self.ln = wc_race
		self.sn = 'Elf'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 1
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 0
		self.skills = {"evasion": {1:10,2:18,3:25}, "thorns_aura": {1:0.10,2:0.15,3:0.20}, "trueshot_aura": {1:0.10,2:0.20,3:0.30}, "entangle_roots": {1:1}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def evasion(self,wc_eventvars,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['evasion']:
				return 0
			wc_lvl = self.skill['evasion']
		if random.randint(1,100) <= self.skills['evasion'][wc_lvl]:
			#es.msg('#lightgreen','Evaded: ' + str(wc_eventvars['dmg_health']) + ' By: ' + es.getplayername(wc_eventvars['attacker']))
			wc_tmp = playerlib.getPlayer(wc_eventvars['userid'])
			wc_tmp.set('health',int(wc_tmp.get('health')) + int(wc_eventvars['dmg_health']))
			wc_tmp.set('armor',int(wc_tmp.get('armor')) + int(wc_eventvars['dmg_armor']))
			wc_users[wc_eventvars['es_steamid']]['evaded'] = 1
		
	def thorns_aura(self,wc_eventvars,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['thorns_aura']:
				return 0
			wc_lvl = self.skill['thorns_aura']
		if wc_eventvars['weapon'] == 'point_hurt':
			if dmg.dmg_check_attacks(int(wc_eventvars['userid'])) in wc_reflecting:
				return 0
		tmp_dmg = float(wc_eventvars['dmg_health']) * self.skills['thorns_aura'][wc_lvl]
		#es.msg('#lightgreen','Thorns for: ' + str(tmp_dmg))
		wc_tmp = dmg.get(self.uid)
		wc_tmp.hurt(int(wc_eventvars['attacker']),int(tmp_dmg),2,"thorns_aura")

	def trueshot_aura(self,wc_eventvars,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['trueshot_aura']:
				return 0
			wc_lvl = self.skill['trueshot_aura']
		if wc_eventvars['weapon'] != 'point_hurt':
			tmp_dmg = float(wc_eventvars['dmg_health']) * self.skills['trueshot_aura'][wc_lvl]
			#es.msg('#lightgreen','Trueshot for: ' + str(tmp_dmg))
			wc_tmp = dmg.get(self.uid)
			wc_tmp.hurt(int(wc_eventvars['userid']),int(tmp_dmg),2,"trueshot_aura")
	
	def entangle_roots(self,wc_victim):
		#es.tell(self.uid,'#green','Entangle Roots activated on ' + es.getplayername(wc_victim))
		wc_tmp = playerlib.getPlayer(wc_victim)
		wc_tmp.set('freeze','1')
		delay = 5.0
		gamethread.delayed(delay,wc_tmp.set,('freeze','0'))
		wc_origin = vecmath.vector(es.getplayerlocation(wc_victim))
		radius = 20
		counter = 0
		while counter <= 7:
			if counter == 0 or counter == 8:
				x1 = radius * -1
			elif counter == 1 or counter == 7:
				x1 = radius * -1 * 100 / 141
			elif counter == 2 or counter == 6:
				x1 = 0
			elif counter == 3 or counter == 5:
				x1 = radius * 100 / 141
			elif counter == 4:
				x1 = radius
			if counter <= 4:
				y1 = math.sqrt( radius * radius - x1 * x1 )
			else:
				y1 = -1 * math.sqrt( radius * radius - x1 * x1 )
			counter += 1
			if counter == 0 or counter == 8:
				x2 = -1 * radius
			elif counter == 1 or counter == 7:
				x2 = -1 * radius * 100 / 141
			elif counter == 2 or counter == 6:
				x2 = 0
			elif counter == 3 or counter == 5:
				x2 = radius * 100 / 141
			elif counter == 4:
				x2 = radius
			if counter <= 4:
				y2 = math.sqrt( radius * radius - x2 * x2)
			else:
				y2 = -1 * math.sqrt( radius * radius - x2 * x2 )
			height = 40 + 2 * counter
			while height > 0:
				start = []
				end = []
				start.append(wc_origin['x'] + x1)
				start.append(wc_origin['y'] + y1)
				start.append(wc_origin['z'] + height)
				end.append(wc_origin['x'] + x2)
				end.append(wc_origin['y'] + y2)
				end.append(wc_origin['z'] + height + 2)
				wc_startvec = es.createvectorstring(start[0],start[1],start[2])
				wc_endvec = es.createvectorstring(end[0],end[1],end[2])
				es.server.queuecmd('est_effect_06 #a!b 0.0 sprites/laser.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 '+ str(delay) +' 10 10 15 0 0 255 0 190 30')
				height -= 16
				#delay += 0.05
			
	def defensive(self,wc_eventvars):
		self.evasion(wc_eventvars)
		self.thorns_aura(wc_eventvars)
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.trueshot_aura(wc_eventvars)
		
	def ultimate(self,wc_victim=0):
		self.entangle_roots(int(wc_victim))
	
	def spawn(self):
		global wc_users
		if self.skill['entangle_roots']:
			wc_users[self.steamid]['ultimate'] = 1
	
wc_races_list['Night Elf'] = {'instance':NElf, 'skills': {"evasion": 'skill', "thorns_aura": 'skill', "trueshot_aura": 'skill', "entangle_roots": 'ult'}} 
wc_races_list['Night Elf']['display'] = ['Evasion','Thorns Aura','TrueShot Aura','Entangle Roots']
wc_races_list['Night Elf']['return'] = ['evasion','thorns_aura','trueshot_aura','entangle_roots']
wc_races_list['Night Elf']['info'] = ['Chance to Completely Evade Enemy Attacks','Returns Partial Damage to the Enemy','Extra Damage on Every Hit','Freezes Enemy for 5 sec']
wc_racelist.append('Night Elf')

class BMage(Race):	
	"Mage Skills"
	def __init__(self, wc_userid, wc_race='Blood Mage'):
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = int(wc_userid)
		wc_race = 'Blood Mage'
		self.ln = wc_race
		self.sn = 'Mage'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 1
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 0
		self.skills = {"pheonix": {1:33,2:66,3:100}, "banish": {1:10,2:15,3:20}, "siphon_mana": {1:0.05,2:0.10,3:0.15}, "flame_strike": {1:1}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def pheonix(self,wc_lvl=0):
		global wc_pheonix_t, wc_pheonix_ct
		if not wc_lvl:
			if not self.skill['pheonix']:
				return 0
			wc_lvl = self.skill['pheonix']
		if random.randint(1,100) <= self.skills['pheonix'][wc_lvl]:
			es.tell(self.uid,'#multi','#lightgreen[ #greenPheonix Enabled #lightgreen]')
			if es.getplayerteam(self.uid) == 2:
				wc_pheonix_t += 1
			else:
				wc_pheonix_ct += 1
		
	def banish(self,wc_eventvars,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['banish']:
				return 0
			wc_lvl = self.skill['banish']
		if random.randint(1,100) <= self.skills['banish'][wc_lvl]:
			wc_x = str(random.randint(-500,500))
			wc_y = str(random.randint(-500,500))
			wc_z = str(random.randint(100,500))
			es.server.queuecmd('est_physpush ' + wc_eventvars['userid'] + ' ' + wc_x + ' ' + wc_y + ' ' + wc_z)

	def siphon_mana(self,wc_eventvars,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['siphon_mana']:
				return 0
			wc_lvl = self.skill['siphon_mana']
		wc_tmp = playerlib.getPlayer(self.uid)
		wc_victim = playerlib.getPlayer(wc_eventvars['userid'])
		wc_cash = int(wc_tmp.get('cash'))
		wc_vcash = int(wc_victim.get('cash'))
		wc_tmpcash = float(wc_vcash) * self.skills['siphon_mana'][wc_lvl]
		wc_cash += int(wc_tmpcash)
		wc_vcash -= int(wc_tmpcash)
		wc_tmp.set('cash',wc_cash)
		wc_victim.set('cash',wc_vcash)
	
	def flame_strike(self,wc_victim):
		wc_attacker = dmg.get(self.uid)
		wc_attacker.hurt(wc_victim,1,1,"flame_strike",0.15,10)
		wc_vector = vecmath.vector(es.getplayerlocation(wc_victim))
		wc_tmp = es.createvectorstring(wc_vector['x'],wc_vector['y'],wc_vector['z'] + 30)
		es.server.queuecmd('est_Effect_20 #a!b 0.0 sprites/flamelet5.vmt ' + wc_tmp +' 1 10 0 50 10')
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.banish(wc_eventvars)
		self.siphon_mana(wc_eventvars)
		
	def ultimate(self,wc_victim=0):
		self.flame_strike(int(wc_victim))
	
	def spawn(self):
		global wc_users
		if wc_users[self.steamid]['spawned'] != 1:
			self.pheonix()
			wc_users[self.steamid]['spawned'] = 1
		if self.skill['flame_strike']:
			wc_users[self.steamid]['ultimate'] = 1
	
wc_races_list['Blood Mage'] = {'instance':BMage, 'skills': {"pheonix": 'skill', "banish": 'skill', "siphon_mana": 'skill', "flame_strike": 'ult'}} 
wc_races_list['Blood Mage']['display'] = ['Pheonix','Banish','Siphon Mana','Flame Strike']
wc_races_list['Blood Mage']['return'] = ['pheonix','banish','siphon_mana','flame_strike']
wc_races_list['Blood Mage']['info'] = ['Respawn Fallen Friends','Slap You Enemies','Steal Your Enemies Cash','Burn 1 victim for 10 sec']
wc_racelist.append('Blood Mage')

class SHunter(Race):	
	"Shadow Hunter"
	def __init__(self, wc_userid, wc_race='Shadow Hunter'):
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = int(wc_userid)
		wc_race = 'Shadow Hunter'
		self.ln = wc_race
		self.sn = 'Hunter'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 0
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 1
		self.skills = {"healing_wave": {1:1,2:3,3:5}, "hex": {1:5,2:10,3:15}, "serpent_ward": {1:1,2:2,3:3}, "voodoo": {1:1}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def healing_wave(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['healing_wave']:
				return 0
			wc_lvl = self.skill['healing_wave']
		wc_users[self.steamid]['rings'] = self.skills['healing_wave'][wc_lvl]
		
	def hex(self,wc_victim,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['hex']:
				return 0
			wc_lvl = self.skill['hex']
		if random.randint(1,100) <= self.skills['hex'][wc_lvl]:
			wc_tmpid = es.getplayersteamid(wc_victim)
			wc_tmp = playerlib.getPlayer(wc_victim)
			if wc_tmpid != 'BOT':
				if not wc_users[wc_tmpid]['disabled']:
					wc_users[wc_tmpid]['disabled'] = 1
					gamethread.delayed(6.0,self.unhex,wc_tmpid)
					wc_tmpspeed = wc_users[wc_tmpid]['speed']
					gamethread.delayed(6.0,wc_tmp.set,('speed',wc_tmpspeed))
					wc_tmpspeed -= 0.5
					wc_tmp.set('speed',wc_tmpspeed)
					#es.tell(self.uid,'#green','Hexed : ' + es.getplayername(wc_victim))
					wc_tmpvec = vecmath.vector(es.getplayerlocation(wc_victim))
					wc_vec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'] + 40.0)
					es.server.queuecmd('est_effect_23 #a!b 0.0 sprites/blueflare1.vmt ' + wc_vec + ' 0.5 1 150')
			else:
				wc_tmp.set('speed','0.5')
				gamethread.delayed(6.0,wc_tmp.set,('speed','1.0'))
				#es.tell(self.uid,'#green','Hexed : ' + es.getplayername(wc_victim))
				wc_tmpvec = vecmath.vector(es.getplayerlocation(wc_victim))
				wc_vec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'] + 40.0)
				es.server.queuecmd('est_effect_23 #a!b 0.0 sprites/blueflare1.vmt ' + wc_vec + ' 0.5 1 150')
			
	def unhex(self,wc_victim):
		global wc_users
		wc_users[wc_victim]['disabled'] = 0

	def spawn_wards(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['serpent_ward']:
				return 0
			wc_lvl = self.skill['serpent_ward']
		wc_users[self.steamid]['ability'] = self.skills['serpent_ward'][wc_lvl]
			
	def serpent_ward_old(self):
		wc_tmp = dmg.get(self.uid)
		wc_tmpvec = vecmath.vector(es.getplayerlocation(self.uid))
		wc_startvec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'])
		wc_tmpvec['z'] += 100.0
		wc_endvec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'])
		wc_tmp.radius(20,1,"serpent_ward",1.0,15,50)
		if int(es.getplayerteam(self.uid)) == 2:
			es.server.queuecmd('est_effect_06 #tsud!b 0.0 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 15 50 50 10 1.5 255 0 0 255 15')
		else:
			es.server.queuecmd('est_effect_06 #csud!b 0.0 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 15 50 50 10 1.5 0 0 255 255 15')
	
	def serpent_ward(self):
		global wc_wardlist, wc_users
		if wc_users[self.steamid]['bombsite'] == 0:
			wc_tmpvec = vecmath.vector(es.getplayerlocation(self.uid))
			wc_startvec = es.createvectorstring(wc_tmpvec['x'] - 25.0,wc_tmpvec['y'] - 25.0,wc_tmpvec['z'] - 300.0)
			wc_endvec = es.createvectorstring(wc_tmpvec['x'] + 25.0,wc_tmpvec['y'] + 25.0,wc_tmpvec['z'] + 300.0)
			wc_team = int(es.getplayerteam(self.uid))
			if wc_team == 2:
				wc_teamflag = '#c!d'
			else:
				wc_teamflag = '#t!d'
			if not wc_wardlist.has_key(self.uid):
				wc_wardlist[self.uid] = {}
			wc_wardnum = wc_users[self.steamid]['ability'] + 1
			wc_wardname = str(self.uid) + 'ward' + str(wc_wardnum)
			wc_wardlist[self.uid][wc_wardname] = {}
			es.server.queuecmd('est_box_trigger ' + wc_teamflag + ' ' + wc_wardname + ' ' + wc_startvec + ' ' + wc_endvec + ' 0.2')
			wc_startvec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'] - 300.0)
			wc_endvec = es.createvectorstring(wc_tmpvec['x'],wc_tmpvec['y'],wc_tmpvec['z'] + 300.0)
			if wc_team == 2:
				wc_wardlist[self.uid][wc_wardname]['effect'] = 'est_effect_06 #a!b 0.0 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 2 50 50 10 1.5 255 0 0 255 15'
				es.server.queuecmd(wc_wardlist[self.uid][wc_wardname]['effect'])
			else:
				wc_wardlist[self.uid][wc_wardname]['effect'] = 'est_effect_06 #a!b 0.0 sprites/lgtning.vmt ' + wc_startvec + ' ' + wc_endvec + ' 10 2 50 50 10 1.5 0 0 255 255 15'
				es.server.queuecmd(wc_wardlist[self.uid][wc_wardname]['effect'])
		else:
			wc_users[self.steamid]['ability'] += 1
			es.tell(self.uid,'#green','Cannot Place Wards in the Bombsite!')
	
	def voodoo(self):
		global wc_users
		wc_users[self.steamid]['voodoo'] = 1
		es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 2.5 0 0 0 255 126')
		gamethread.delayed(3.0,self.unvoodoo,)
		
	def unvoodoo(self):
		global wc_users
		wc_users[self.steamid]['voodoo'] = 0
		es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 0.1 0 255 255 255 126')
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.hex(wc_eventvars['userid'])
		
	def ultimate(self,wc_victim=0):
		self.voodoo()
	
	def ability(self):
		self.serpent_ward()
	
	def spawn(self):
		global wc_users
		self.spawn_wards()
		self.healing_wave()
		if self.skill['voodoo']:
			wc_users[self.steamid]['ultimate'] = 1
			
	def victim_death(self,wc_eventvars):
		global wc_users, wc_wardlist
		wc_users[self.steamid]['rings'] = 0
		wc_users[self.steamid]['ability'] = 0
		if wc_wardlist.has_key(self.uid):
			for wc_tmp in wc_wardlist[self.uid].keys():
				es.server.queuecmd('est_box_remove ' + wc_tmp)
			del wc_wardlist[self.uid]
	
wc_races_list['Shadow Hunter'] = {'instance':SHunter, 'skills': {"healing_wave": 'skill', "hex": 'skill', "serpent_ward": 'skill', "voodoo": 'ult'}} 
wc_races_list['Shadow Hunter']['display'] = ['Healing Wave','Hex','Serpent Wards','Big Bad Voodoo']
wc_races_list['Shadow Hunter']['return'] = ['healing_wave','hex','serpent_ward','voodoo']
wc_races_list['Shadow Hunter']['info'] = ['Regerate Lost HP, max 5hp/2sec','Disables Enemy Offensive Skills, and Slows Them','Wards that Damage Enemies, 1 Per Level','Invincible for 3 sec, But Cannot Hurt Enemies']
wc_racelist.append('Shadow Hunter')

class Warden(Race):	
	"Warden"
	def __init__(self, wc_userid, wc_race='Warden'):
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = int(wc_userid)
		wc_race = 'Warden'
		self.ln = wc_race
		self.sn = 'Warden'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 0
		self.ult_target = 0
		self.ult_coord = 0
		self.ult_skill = 0
		self.skills = {"fan_of_knives": {1:10,2:15,3:20}, "blink": {1:1,2:2,3:3}, "shadow_strike": {1:10,2:15,3:20}, "vengeance": {1:50}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def fan_of_knives(self,wc_lvl=0):
		global wc_users, wc_moles
		if not wc_lvl:
			if not self.skill['fan_of_knives']:
				return 0
			wc_lvl = self.skill['fan_of_knives']
		if wc_lvl == 100:
			wc_users[self.steamid]['mole'] = 1
		elif random.randint(1,100) <= self.skills['fan_of_knives'][wc_lvl]:
			wc_users[self.steamid]['mole'] = 1
		if wc_users[self.steamid]['mole'] == 1:
			es.tell(self.uid,'#multi','#lightgreen[#green Prepare to Mole! #lightgreen]')
			#es.server.queuecmd('est_csay ' + str(self.uid) + ' Prepare to mole!')
			es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 0.5 0 255 255 255 126')
			wc_moles[self.uid] = int(es.getplayerteam(self.uid))
		
	def blink(self,wc_lvl=0):
		global wc_users
		if not wc_lvl:
			if not self.skill['blink']:
				return 0
			wc_lvl = self.skill['blink']
		wc_users[self.steamid]['blink'] += self.skills['blink'][wc_lvl]
			
	def shadow_strike(self,wc_victim,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['shadow_strike']:
				return 0
			wc_lvl = self.skill['shadow_strike']
		if random.randint(1,100) <= self.skills['shadow_strike'][wc_lvl]:
			#es.tell(self.uid,'#green','Shadow Strike on: ' + es.getplayername(wc_victim))
			wc_tmp = dmg.get(self.uid)
			tmp_dmg = random.randint(15,30)
			wc_tmp.hurt(int(wc_victim),tmp_dmg,131072,"shadow_strike",1.0,3.0)
			wc_tmp = vecmath.vector(es.getplayerlocation(wc_victim))
			wc_origin = es.createvectorstring(wc_tmp['x'],wc_tmp['y'],wc_tmp['z'] + 50.0)
			wc_angle = es.getplayerprop(wc_victim,'CBasePlayer.baseclass.baseclass.baseclass.baseclass.baseclass.m_angRotation')
			wc_angle2 = wc_angle.split(",")
			wc_angle = es.createvectorstring(wc_angle2[0],wc_angle2[1],wc_angle2[2])
			wc_tmp = []
			wc_tmp.append(float(random.randint(1,150)))
			wc_tmp.append(float(random.randint(1,150)))
			wc_tmp.append(float(random.randint(1,150)))
			wc_size = es.createvectorstring(wc_tmp[0],wc_tmp[1],wc_tmp[2])
			wc_tmp = []
			wc_tmp.append(float(random.randint(1,150)))
			wc_tmp.append(float(random.randint(1,150)))
			wc_tmp.append(float(random.randint(1,150)))
			wc_vel = es.createvectorstring(wc_tmp[0],wc_tmp[1],wc_tmp[2])
			es.server.queuecmd('est_Effect_12 #a!b 0.0 sprites/blood.vmt ' + wc_origin + ' ' + wc_angle + ' ' + wc_size + ' ' + wc_vel + ' 50 5 1.0 1')
	
	def vengeance(self):
		global wc_users
		wc_users[self.steamid]['vengeance'] = self.skills['vengeance'][1]
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.shadow_strike(wc_eventvars['userid'])
		
	def spawn(self):
		global wc_users
		if wc_users[self.steamid]['spawned'] != 1:
			self.fan_of_knives()
			if self.skill['vengeance']:
				wc_users[self.steamid]['ultimate'] = 1
				self.vengeance()
			wc_users[self.steamid]['spawned'] = 1
		self.blink()
	
wc_races_list['Warden'] = {'instance':Warden, 'skills': {"fan_of_knives": 'skill', "blink": 'skill', "shadow_strike": 'skill', "vengeance": 'ult'}} 
wc_races_list['Warden']['display'] = ['Fan of Knives','Blink','Shadow Strike','Vengeance']
wc_races_list['Warden']['return'] = ['fan_of_knives','blink','shadow_strike','vengeance']
wc_races_list['Warden']['info'] = ['Chance to Spawn With Enemies, Disguised as one','Blocks 1 Ultimate Per Level','Damages Enemy With Poison','Respawn Once With 50hp']
wc_racelist.append('Warden')

class CLord(Race):	
	"Warden"
	def __init__(self, wc_userid, wc_race='Crypt Lord'):
		wc_steamid = es.getplayersteamid(wc_userid)
		self.steamid = wc_steamid
		self.uid = int(wc_userid)
		wc_race = 'Crypt Lord'
		self.ln = wc_race
		self.sn = 'Crypt Lord'
		self.race = wc_race
		self.level = wc_users[wc_steamid][wc_race]['level']
		self.ult_viewtarget = 0
		self.ult_target = 1
		self.ult_coord = 0
		self.ult_skill = 0
		self.skills = {"impale": {1:10,2:15,3:20}, "spiked_carapace": {1:0.10,2:0.15,3:0.20}, "carrion_beetles": {1:10,2:15,3:20}, "locust_swarm": {1:1}}
		self.skill = {}
		for wc_tmp in self.skills:
			self.skill[wc_tmp] = wc_users[wc_steamid][wc_race][wc_tmp]
		
	def impale(self,wc_victim,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['impale']:
				return 0
			wc_lvl = self.skill['impale']
		if random.randint(1,100) <= self.skills['impale'][wc_lvl]:
			es.server.queuecmd('est_shake ' + str(wc_victim) + ' 2 50 50')
			#es.tell(self.uid,'#green','Impaled victim')
		
	def spiked_carapace(self,wc_eventvars,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['spiked_carapace']:
				return 0
			wc_lvl = self.skill['spiked_carapace']
		tmp_dmg = float(wc_eventvars['dmg_health']) * self.skills['spiked_carapace'][wc_lvl]
		wc_tmp = dmg.get(self.uid)
		wc_tmp.hurt(int(wc_eventvars['attacker']),int(tmp_dmg),2,"spiked_carapace")
		wc_tmpme = playerlib.getPlayer(self.uid)
		wc_armor = int(wc_tmpme.get('armor')) + tmp_dmg * 2
		wc_tmpme.set('armor',wc_armor)
		#es.tell(self.uid,'#green','Damage: ' + str(tmp_dmg) + ' Armor set to: ' + str(wc_armor))
			
	def carrion_beetles(self,wc_victim,wc_lvl=0):
		if not wc_lvl:
			if not self.skill['carrion_beetles']:
				return 0
			wc_lvl = self.skill['carrion_beetles']
		if random.randint(1,100) <= self.skills['carrion_beetles'][wc_lvl]:
			wc_tmp = dmg.get(self.uid)
			tmp_dmg = random.randint(20,35)
			wc_tmp.hurt(int(wc_victim),tmp_dmg,2,"carrion_beetles")
			wc_vec = vecmath.vector(es.getplayerlocation(self.uid))
			wc_vec1 = es.createvectorstring(wc_vec['x'],wc_vec['y'],wc_vec['z'] + 45.0)
			wc_vec = vecmath.vector(es.getplayerlocation(wc_victim))
			wc_vec2 = es.createvectorstring(wc_vec['x'],wc_vec['y'],wc_vec['z'] + 45.0)
			es.server.queuecmd('est_effect_15 #a!b 0.0 sprites/bubble.vmt ' + wc_vec1 + ' ' + wc_vec2 + ' 245 75 15')
	
	def locust_swarm(self,wc_victim):
		if int(wc_victim) > 0:
			wc_attacker = dmg.get(self.uid)
			wc_attacker.hurt(int(wc_victim),35,1,"locust_swarm")
			wc_tmp = vecmath.vector(es.getplayerlocation(wc_victim))
			wc_vec1 = es.createvectorstring(wc_tmp['x'],wc_tmp['y'],wc_tmp['z'])
			wc_vec2 = es.createvectorstring(wc_tmp['x'],wc_tmp['y'],wc_tmp['z'] + 25.0)
			wc_vec3 = es.createvectorstring(wc_tmp['x'],wc_tmp['y'],wc_tmp['z'] + 45.0)
			es.server.queuecmd('est_effect_31 #a!b 0.0 sprites/smoke.vmt ' + wc_vec1 + ' 10 15')
			es.server.queuecmd('est_effect_31 #a!b 0.05 sprites/smoke.vmt ' + wc_vec2 + ' 10 15')
			es.server.queuecmd('est_effect_31 #a!b 0.1 sprites/smoke.vmt ' + wc_vec3 + ' 10 15')
			es.server.queuecmd('est_fade ' + str(self.uid) + ' 0 0.5 0 0 255 0 126')
		
	def offensive(self,wc_eventvars,wc_kill):
		if not wc_kill:
			self.impale(wc_eventvars['userid'])
			self.carrion_beetles(wc_eventvars['userid'])
		
	def defensive(self,wc_eventvars):
		self.spiked_carapace(wc_eventvars)
		
	def ultimate(self,wc_victim=0):
		self.locust_swarm(wc_victim)
		
	def spawn(self):
		global wc_users
		if self.skill['locust_swarm']:
			wc_users[self.steamid]['ultimate'] = 1
	
wc_races_list['Crypt Lord'] = {'instance':CLord, 'skills': {"impale": 'skill', "spiked_carapace": 'skill', "carrion_beetles": 'skill', "locust_swarm": 'ult'}} 
wc_races_list['Crypt Lord']['display'] = ['Impale','Spiked Carapace','Carrion Beetles','Locust Swarm']
wc_races_list['Crypt Lord']['return'] = ['impale','spiked_carapace','carrion_beetles','locust_swarm']
wc_races_list['Crypt Lord']['info'] = ['Shakes Victims Screen','Returns Partial Damage, and Gives Armor','Damage Victim With Beetles','Damages a Random Victim']
wc_racelist.append('Crypt Lord')

#items
class wc_Items(object):
	"Master Class for Shop Menu Items"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'None'
		self.itemrace = 'None'
		self.itemskill = 'None'
		
	# anything events you check for should be added to this list
	# this is the default set of events I've added to look for
	# I suggest remaking this with just the ones you need
	# inside each item, so it cuts down on the processing
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'player_hurt_victim':
			self.player_hurt_victim(wc_eventvars,wc_slot)
		elif wc_event == 'player_hurt_attacker':
			self.player_hurt_attacker(wc_eventvars,wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'attacker_death':
			self.attacker_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
	
	# these are very important
	# these are the default functions incase your item doens't use it
	# this is so you don't have to worry about it if you don't need it
	# this avoids things breaking later on, make sure this is always up to date
	def item_purchased(self,wc_slot=0):
		return 0
		
	def item_drop(self,wc_slot=0,wc_item="None"):
		global wc_users
		if wc_users[self.steamid]['items'].has_key(wc_slot):
			if wc_users[self.steamid]['items'][wc_slot].has_key(wc_item):
				del wc_users[self.steamid]['items'][wc_slot][wc_item]
		
	def player_passive(self,wc_slot=0):
		return 0
		
	def player_hurt_victim(self,wc_eventvars,wc_slot=0):
		return 0
		
	def player_hurt_attacker(self,wc_eventvars,wc_slot=0):
		return 0
		
	def victim_death(self,wc_eventvars,wc_slot=0):
		return 0
		
	def attacker_death(self,wc_eventvars,wc_slot=0):
		return 0
		
class Ankh(wc_Items):
	"Ankh of Reincarnation"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Ankh of Reincarnation'
		self.itemrace = 'Orcish Horde'
		self.itemskill = 'equipment_reincarnation'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'vengeance'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] = 0
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				if wc_tmp2.get('isdead') == 1:
					wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] = 1
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Ankh of Reincarnation'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] == 0:
			return 0
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.equipment_reincarnation(3)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] = 1
	
wc_items_list[1]['Ankh of Reincarnation'] = {'call': Ankh, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'vengeance', 'total': 1, 'price': 2000}
wc_items_list[1]['Ankh of Reincarnation']['info'] = 'Regenerates Your Last Weapons Once'
wc_items_list[1]['Menu'].append('Ankh of Reincarnation')
		
class Boots(wc_Items):
	"Boots of Speed"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Boots of Speed'
		self.itemrace = 'Undead Scourge'
		self.itemskill = 'unholy_aura'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'unholy_aura'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
				wc_tmp.unholy_aura(2)
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Boots of Speed'):
		global wc_users
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.unholy_aura(-1)
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=1):
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.unholy_aura(2)
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Boots of Speed'] = {'call': Boots, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'unholy_aura', 'total': 1, 'price': 3500}
wc_items_list[1]['Boots of Speed']['info'] = 'Grants Speed Boost'
wc_items_list[1]['Menu'].append('Boots of Speed')

class Claws(wc_Items):
	"Claws"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Claws'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'player_hurt_attacker':
			self.player_hurt_attacker(wc_eventvars,wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
		
	def item_purchased(self,wc_slot=1):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_hurt_attacker','victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'None'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	# this function .drop_item()  is not actually needed, but it's probably faster with it
	# for the sake of arguement, you can leave it out if this is all you're doing
	# you just need to make sure you tell it the proper  slot and item name when dropping it
	# the original code should do this by default
	def drop_item(self,wc_slot=1,wc_item='Claws'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_hurt_attacker(self,wc_eventvars,wc_slot=1):
		wc_tmp = dmg.get(int(wc_eventvars['attacker']))
		wc_tmp.hurt(wc_eventvars['userid'],6,1,"Claws")
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		for wc_tmp in wc_users[self.steamid]['items']:
			if wc_users[self.steamid]['items'][wc_tmp].has_key(self.itemname):
				self.drop_item(1,self.itemname)
		
wc_items_list[1]['Claws'] = {'call': Claws, 'events': ['player_hurt_attacker','victim_death','item_drop'], 'skill': 'None','total': 1, 'price': 2500}
wc_items_list[1]['Claws']['info'] = 'Deals +6 Extra Damage Per Hit'
wc_items_list[1]['Menu'].append('Claws')

class Cloak(wc_Items):
	"Cloak of Shadows"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Cloak of Shadows'
		self.itemrace = 'Human Alliance'
		self.itemskill = 'invisibility'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'invisibility'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
				wc_tmp.invisibility(2)
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Ankh of Reincarnation'):
		global wc_users
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.invisibility(-1)
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=1):
		global wc_users
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.invisibility(2)
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Cloak of Shadows'] = {'call': Cloak, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'invisibility', 'total': 1, 'price': 3500}
wc_items_list[1]['Cloak of Shadows']['info'] = 'Gives Partial Invisibility'
wc_items_list[1]['Menu'].append('Cloak of Shadows')

class Mask(wc_Items):
	"Mask of Death"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Mask of Death'
		self.itemrace = 'Undead Scourge'
		self.itemskill = 'vamp_aura'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_hurt_attacker':
			self.player_hurt_attacker(wc_eventvars,wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_hurt_attacker','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'vamp_aura'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Mask of Death'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_hurt_attacker(self,wc_eventvars,wc_slot=1):
		global wc_users
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.vamp_aura(wc_eventvars['userid'],wc_eventvars['dmg_health'],2)
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Mask of Death'] = {'call': Mask, 'events': ['player_hurt_attacker','victim_death','item_drop'], 'skill': 'vamp_aura', 'total': 1, 'price': 3500}
wc_items_list[1]['Mask of Death']['info'] = 'Gain Health When You Deal Damage'
wc_items_list[1]['Menu'].append('Mask of Death')

class Necklace(wc_Items):
	"Necklace of Immunity"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Necklace of Immunity'
		self.itemrace = 'Warden'
		self.itemskill = 'blink'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'blink'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_users[self.steamid]['blink'] += 1
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Necklace of Immunity'):
		global wc_users
		if wc_users[self.steamid]['blink'] > 0:
			wc_users[self.steamid]['blink'] -= 1
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=1):
		global wc_users
		wc_users[self.steamid]['blink'] += 1
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Necklace of Immunity'] = {'call': Necklace, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'blink', 'total': 1, 'price': 1500}
wc_items_list[1]['Necklace of Immunity']['info'] = 'Lets You Block 1 Ultimate Per Round'
wc_items_list[1]['Menu'].append('Necklace of Immunity')

class Orb(wc_Items):
	"Orb of Frost"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemrace = 'Shadow Hunter'
		self.itemname = 'Orb of Frost'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_hurt_attacker':
			self.player_hurt_attacker(wc_eventvars,wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_hurt_attacker','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'hex'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Orb of Frost'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_hurt_attacker(self,wc_eventvars,wc_slot=1):
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.hex(int(wc_eventvars['userid']),2)
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Orb of Frost'] = {'call': Orb, 'events': ['player_hurt_attacker','victim_death','item_drop'], 'skill': 'hex', 'total': 1, 'price': 2500}
wc_items_list[1]['Orb of Frost']['info'] = 'Chance to Slow Victims, and Disable Offensive Skills'
wc_items_list[1]['Menu'].append('Orb of Frost')

class Periapt(wc_Items):
	"Periapt of Health"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Periapt of Health'
		self.itemrace = 'Human Alliance'
		self.itemskill = 'devotion_aura'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'devotion_aura'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
				wc_tmp.devotion_aura(2)
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=1,wc_item='Boots of Speed'):
		global wc_users
		wc_tmp = playerlib.getPlayer(self.uid)
		if wc_tmp.get('health') > 30:
			wc_tmp.set('health',wc_tmp.get('health') - 30)
			wc_users[self.steamid]['maxhp'] -= 30
			wc_tmpcash = int(wc_tmp.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp.set('cash',wc_tmpcash)
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		elif wc_tmp.get('isdead') != 0:
			wc_users[self.steamid]['maxhp'] -= 30
			wc_tmpcash = int(wc_tmp.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp.set('cash',wc_tmpcash)
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','Not enough HP to drop this item')
		
	def player_passive(self,wc_slot=1):
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.devotion_aura(2)
		
	def victim_death(self,wc_eventvars,wc_slot=1):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[1]['Periapt of Health'] = {'call': Periapt, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'devotion_aura', 'total': 1, 'price': 1500}
wc_items_list[1]['Periapt of Health']['info'] = 'Adds 30 to Your Max HP'
wc_items_list[1]['Menu'].append('Periapt of Health')

class Tome(wc_Items):
	"Tome of Experience"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Tome of Experience'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
			
	def item_purchased(self,wc_slot=1):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			give_xp(self.steamid,'purchasing Tome of Experience',100)
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
	
wc_items_list[1]['Tome of Experience'] = {'call': Tome, 'events': ['none'], 'skill': 'None', 'total': 1, 'price': 9000}
wc_items_list[1]['Tome of Experience']['info'] = 'Gives 100 XP'
wc_items_list[1]['Menu'].append('Tome of Experience')

class Scroll(wc_Items):
	"Scroll of Respawning"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Scroll of Respawning'
		self.itemrace = 'Warden'
		self.itemskill = 'vengeance'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'vengeance'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_users[self.steamid]['vengeance'] = 100
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=2,wc_item='Scroll of Respawning'):
		global wc_users
		wc_users[self.steamid]['vengeance'] = 0
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=1):
		global wc_users
		wc_users[self.steamid]['vengeance'] = 100
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Scroll of Respawning'] = {'call': Scroll, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'vengeance', 'total': 1, 'price': 8000}
wc_items_list[2]['Scroll of Respawning']['info'] = 'Respawn Once With Full HP'
wc_items_list[2]['Menu'].append('Scroll of Respawning')

class Mprotect(wc_Items):
	"Mole Protectant"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Mole Protectant'
		self.itemskill = 'none'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'none'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=2,wc_item='Mole Protectant'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Mole Protectant'] = {'call': Mprotect, 'events': ['victim_death','item_drop'], 'skill': 'none', 'total': 1, 'price': 1500}
wc_items_list[2]['Mole Protectant']['info'] = 'Makes You Immune to Attacks From Moles'
wc_items_list[2]['Menu'].append('Mole Protectant')

class Amulet(wc_Items):
	"Amulet of the Cat"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Amulet of the Cat'
		self.itemskill = 'none'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'none'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] = 1
			es.setplayerprop(self.uid,"CBasePlayer.m_fFlags","2097152")
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=2,wc_item='Amulet of the Cat'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		es.setplayerprop(self.uid,"CBasePlayer.m_fFlags","1")
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=2):
		global wc_users
		es.setplayerprop(self.uid,"CBasePlayer.m_fFlags","2097152")
		wc_users[self.steamid]['items'][wc_slot][self.itemname]['set'] = 1
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Amulet of the Cat'] = {'call': Amulet, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'none', 'total': 1, 'price': 3500}
wc_items_list[2]['Amulet of the Cat']['info'] = 'Makes You Move Quietly, Type !cat to Turn On/Off'
wc_items_list[2]['Menu'].append('Amulet of the Cat')

class Sock(wc_Items):
	"Sock of the Feather"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Sock of the Feather'
		self.itemrace = 'Undead Scourge'
		self.itemskill = 'levitation'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'levitation'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
				wc_tmp.levitation(2)
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=2,wc_item='Amulet of the Cat'):
		global wc_users
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.levitation(-1)
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=2):
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.levitation(2)
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Sock of the Feather'] = {'call': Sock, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'levitation', 'total': 1, 'price': 3500}
wc_items_list[2]['Sock of the Feather']['info'] = 'Gives Low Gravity'
wc_items_list[2]['Menu'].append('Sock of the Feather')

class Helm(wc_Items):
	"Helm of Excellence"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Helm of Excellence'
		self.itemskill = 'none'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'none'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['charges'] = 5
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['broken'] = 0
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def drop_item(self,wc_slot=2,wc_item='Helm of Excellence'):
		global wc_users
		if wc_users[self.steamid]['items'][wc_slot][self.itemname]['charges'] > 0:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_items_list[wc_slot][self.itemname]['price'] / 5 * wc_users[self.steamid]['items'][wc_slot][self.itemname]['charges'])
			wc_tmpcash += int(wc_tmp2.get('cash'))
			wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=2):
		global wc_users
		wc_users[self.steamid]['items'][wc_slot][self.itemname]['charges'] = 5
		wc_users[self.steamid]['items'][wc_slot][self.itemname]['broken'] = 0
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Helm of Excellence'] = {'call': Helm, 'events': ['victim_death','item_drop'], 'skill': 'none', 'total': 1, 'price': 7000}
wc_items_list[2]['Helm of Excellence']['info'] = 'Makes You Immune to Head Shots'
wc_items_list[2]['Menu'].append('Helm of Excellence')

class Gloves(wc_Items):
	"Flaming Gloves of Warmth"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Flaming Gloves of Warmth'
		self.itemrace = 'Orcish Horde'
		self.itemskill = 'none'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users, wc_nadelist
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'none'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			wc_nadelist[self.uid] = 1
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			if wc_glove_orc_damage == 0 and wc_users[self.steamid]['race'] == self.itemrace:
				es.tell(self.uid,'#green','Critical Grenades are Disabled while you have ' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def player_passive(self,wc_slot=2):
		global wc_nadelist
		wc_nadelist[self.uid] = 1
		if wc_glove_orc_damage == 0 and wc_users[self.steamid]['race'] == self.itemrace:
			es.tell(self.uid,'#green','Critical Grenades are Disabled while you have ' + self.itemname)
		
	def drop_item(self,wc_slot=2,wc_item='Flaming Gloves of Warmth'):
		global wc_users, wc_nadelist
		del wc_nadelist[self.uid]
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users, wc_nadelist
		del wc_nadelist[self.uid]
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Flaming Gloves of Warmth'] = {'call': Gloves, 'events': ['victim_death','item_drop'], 'skill': 'none', 'total': 1, 'price': 5000}
wc_items_list[2]['Flaming Gloves of Warmth']['info'] = 'Regenerates HE Grenades Every 10 Seconds'
wc_items_list[2]['Menu'].append('Flaming Gloves of Warmth')

class Rings(wc_Items):
	"Ring of Regeneration"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Ring of Regeneration'
		self.itemrace = 'Shadow Hunter'
		self.itemskill = 'healing_wave'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'healing_wave'
				if wc_users[self.steamid]['rings'] < wc_regen_max:
					wc_users[self.steamid]['rings'] += 1
					wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = wc_users[self.steamid]['rings']
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				if wc_users[self.steamid]['rings'] == 0:
					del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def drop_item(self,wc_slot=2,wc_item='Ring of Regeneration'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + (wc_items_list[wc_slot][self.itemname]['price'] * wc_users[self.steamid]['rings'])
		wc_tmp2.set('cash',wc_tmpcash)
		wc_users[self.steamid]['rings'] = 0
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=2):
		global wc_users
		wc_users[self.steamid]['rings'] = wc_users[self.steamid]['items'][wc_slot][self.itemname]['total']
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		wc_users[self.steamid]['rings'] = 0
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Ring of Regeneration'] = {'call': Rings, 'events': ['victim_death','item_drop'], 'skill': 'healing_wave', 'total': 5, 'price': 1000}
wc_items_list[2]['Ring of Regeneration']['info'] = 'Regenerate you and your teammates HP 1 Every 2 Seconds, Per Ring'
wc_items_list[2]['Menu'].append('Ring of Regeneration')

class Disguise(wc_Items):
	"Chameleon"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Chameleon'
		self.itemskill = 'none'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'victim_death':
			self.victim_death(wc_eventvars,wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash'))
		if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['victim_death','item_drop']
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'none'
			wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
			disguiser(self.uid)
			wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
			wc_tmp2.set('cash',wc_tmpcash)
			es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
		else:
			es.tell(self.uid,'#green','You do not have enough cash')
			del wc_users[self.steamid]['items'][wc_slot][self.itemname]

	def player_passive(self,wc_slot=2):
		disguiser(self.uid)
		
	def drop_item(self,wc_slot=2,wc_item='Chameleon'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def victim_death(self,wc_eventvars,wc_slot=2):
		global wc_users
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Chameleon'] = {'call': Disguise, 'events': ['victim_death','item_drop'], 'skill': 'none', 'total': 1, 'price': 8000}
wc_items_list[2]['Chameleon']['info'] = 'Makes You Look Like the Other Team'
wc_items_list[2]['Menu'].append('Chameleon')

class Mole(wc_Items):
	"Mole"
	def __init__(self,wc_userid):
		self.uid = int(wc_userid)
		self.steamid = es.getplayersteamid(wc_userid)
		self.itemname = 'Mole'
		self.itemrace = 'Warden'
		self.itemskill = 'fan_of_knives'
		
	def event_handle(self,wc_event,wc_eventvars,wc_slot):
		if wc_event == 'player_passive':
			self.player_passive(wc_slot)
		elif wc_event == 'item_purchased':
			self.item_purchased(wc_slot)
		elif wc_event == 'item_drop':
			self.item_drop(wc_slot,self.itemname)
			
	def item_purchased(self,wc_slot=2):
		global wc_users
		if wc_users[self.steamid]['race'] != self.itemrace:
			wc_tmp2 = playerlib.getPlayer(self.uid)
			wc_tmpcash = int(wc_tmp2.get('cash'))
			if wc_tmpcash >= wc_items_list[wc_slot][self.itemname]['price']:
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['events'] = ['player_passive','victim_death','item_drop']
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['skill'] = 'fan_of_knives'
				wc_users[self.steamid]['items'][wc_slot][self.itemname]['total'] = 1
				wc_tmpcash -= wc_items_list[wc_slot][self.itemname]['price']
				wc_tmp2.set('cash',wc_tmpcash)
				es.tell(self.uid,'#multi','#greenYou Have Purchased #lightgreen' + self.itemname)
			else:
				es.tell(self.uid,'#green','You do not have enough cash')
				del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		else:
			es.tell(self.uid,'#green','You cannot purchase this while being ' + str(self.itemrace))
			self.drop_item()

	def drop_item(self,wc_slot=2,wc_item='Mole'):
		global wc_users
		wc_tmp2 = playerlib.getPlayer(self.uid)
		wc_tmpcash = int(wc_tmp2.get('cash')) + wc_items_list[wc_slot][self.itemname]['price']
		wc_tmp2.set('cash',wc_tmpcash)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
		
	def player_passive(self,wc_slot=2):
		wc_tmp = wc_races_list[self.itemrace]['instance'](self.uid)
		wc_tmp.fan_of_knives(100)
		del wc_users[self.steamid]['items'][wc_slot][self.itemname]
	
wc_items_list[2]['Mole'] = {'call': Mole, 'events': ['player_passive','victim_death','item_drop'], 'skill': 'fan_of_knives', 'total': 1, 'price': 15000}
wc_items_list[2]['Mole']['info'] = 'Spawn With the Other Team, and Look Like Them'
wc_items_list[2]['Menu'].append('Mole')

# game events
def load():
	global wc_skills, wc_users, wc_weapontracking, wc_nadelist, wc_wardlist, wc_bombsites, wc_headshots
	es.server.queuecmd('es_xset wcs2_version \"1.0 beta 1\"')
	es.server.queuecmd('es_makepublic cw_version')
	if os.path.exists(es.getAddonPath('wcs2') + "/wc_skills.db"):
		#es.msg('#green','db laoding')
		wc_file = open(es.getAddonPath('wcs2') + "/wc_skills.db",'rb')
		wc_skills = pickle.load(wc_file)
		wc_file.close()
	else:
		#es.msg('#green','no db')
		wc_skills = {}
	wc_users = {}
	es.set('wc_victim','0')
	es.set('wc_weapon_return','0')
	es.set('wc_victim_return','0')
	es.set('wc_x','0')
	es.set('wc_y','0')
	es.set('wc_z','0')
	es.doblock('corelib/noisy_on')
	es.server.queuecmd('est_RegEventBlock player_death \"es_doblock wcs2/wc_death\"')
	es.addons.registerSayFilter(wc_sayfilter)
	es.regclientcmd('!ultimate','wcs2/use_ultimate')
	es.regclientcmd('!ability','wcs2/use_ability')
	wc_nadelist = {}
	wc_headshots = {}
	wc_wardlist = {}
	wc_bombsites = {}
	regeneration()
	regen_nades()
	wards_loop()
	wc_tspawn = {}
	wc_ctspawn = {}
	wc_weapontracking = {}
	wc_tspawn = es.createentitylist('info_player_terrorist')
	wc_ctspawn = es.createentitylist('info_player_counterterrorist')

def unload():
	global wc_skills, wc_users
	for wc_tmp in wc_users:
		set_in_db(wc_tmp)
	wc_file = open(es.getAddonPath('wcs2') + "/wc_skills.db",'wb')
	pickle.dump(wc_skills,wc_file)
	wc_file.close()
	wc_skills = None
	wc_users = None
	stop_timers()
	es.doblock('corelib/noisy_off')
	es.server.queuecmd('est_unRegEventBlock player_death \"es_doblock wcs2/wc_death\"')
	es.addons.unregisterSayFilter(wc_sayfilter)
	es.unregclientcmd('!ultimate')
	es.unregclientcmd('!ability')
	es.server.queuecmd('es_xset wcs2_version \"\"')

def es_map_start(event_var):
	global wc_skills, wc_users, wc_pheonix_t, wc_pheonix_ct, wc_weapontracking, wc_bombsites, wc_wardlist
	#es.msg('#green','map starting')
	#es.dbgmsg(0,'map starting')
	wc_pheonix_t = 0
	wc_pheonix_ct = 0
	if not len(wc_skills):
		for wc_tmp in wc_users:
			set_in_db(wc_tmp)
		wc_file = open(es.getAddonPath('wcs2') + "/wc_skills.db",'wb')
		pickle.dump(wc_skills,wc_file)
		wc_file.close()
		wc_skills = {}
	wc_file = open(es.getAddonPath('wcs2') + "/wc_skills.db",'rb')
	wc_skills = pickle.load(wc_file)
	wc_file.close()
	wc_users = {}
	wc_wardlist = {}
	wc_nadelist = {}
	wc_bombsites = {}
	wc_weapontracking = {}
	#regeneration()
	#regen_nades()
	
def weapon_fire(event_var):
	if event_var['es_steamid'] != 'BOT':
		if event_var['weapon'] == 'hegrenade':
			tmp_eventvars = {}
			tmp_eventvars['userid'] = event_var['userid']
			tmp_eventvars['weapon'] = event_var['weapon']
			tmp_eventvars['es_username'] = event_var['es_username']
			tmp_eventvars['es_steamid'] = event_var['es_steamid']
			tmp_eventvars['es_userteam'] = event_var['es_userteam']
			tmp_eventvars['es_userhealth'] = event_var['es_userhealth']
			tmp_eventvars['es_userarmor'] = event_var['es_userarmor']
			tmp_eventvars['es_userdeaths'] = event_var['es_userdeaths']
			tmp_eventvars['es_userkills'] = event_var['es_userkills']
			tmp_eventvars['es_userweapon'] = event_var['es_userweapon']
			wc_users[event_var['es_steamid']]['object'].grenade_toss(tmp_eventvars)
		
def item_pickup(event_var):
	global wc_weapontracking
	if event_var['es_steamid'] != 'BOT':
		if wc_weapontracking.has_key(event_var['userid']):
			if wc_weapontracking[event_var['userid']]['spawn'] == 1 and event_var['item'] in wc_pistol:
				wc_weapontracking[event_var['userid']]['spawn'] = 0
			else:
				if event_var['item'] in wc_primary:
					wc_weapontracking[event_var['userid']]['primary'] = 'weapon_' + event_var['item']
					#es.tell(event_var['userid'],'#green','tracking primary: ' + wc_weapontracking[event_var['userid']]['primary'])
				elif event_var['item'] in wc_pistol:
					wc_weapontracking[event_var['userid']]['pistol'] = 'weapon_' + event_var['item']
	
def player_jump(event_var):
	global wc_users
	if event_var['es_steamid'] != 'BOT':
		if wc_users.has_key(event_var['es_steamid']):
			if check_hasitem(int(event_var['userid']),'Amulet of the Cat') != 0:
				wc_userid = int(event_var['userid'])
				wc_steamid = event_var['es_steamid']
				if wc_users[wc_steamid]['items'][2]['Amulet of the Cat']['set'] == 1:
					if wc_users[wc_steamid]['gravity'] == 1.0:
						gamethread.delayed(1.0,es.setplayerprop,(wc_userid,"CBasePlayer.m_fFlags","2097152"))
					else:
						gamethread.delayed(1.5,es.setplayerprop,(wc_userid,"CBasePlayer.m_fFlags","2097152"))
			if wc_users[event_var['es_steamid']]['gravity'] != 1.0:
				es.server.queuecmd('es_fire %s !self addoutput \"gravity %f\"' % (event_var['userid'], wc_users[event_var['es_steamid']]['gravity']))
	
def player_hurt(event_var):
	global wc_users, wc_headshots
	if event_var['attacker'] != '0' and event_var['attacker'] != 'world' and event_var['attacker'] != 'world_spawn' and event_var['attacker'] != event_var['userid']:
		wc_helmtest = 0
		wc_evaded = 0
		wc_kill = 0
		tmp_eventvars = {}
		#event specific
		tmp_eventvars['userid'] = event_var['userid']
		tmp_eventvars['attacker'] = event_var['attacker']
		tmp_eventvars['weapon'] = event_var['weapon']
		tmp_eventvars['health'] = event_var['health']
		tmp_eventvars['dmg_health'] = event_var['dmg_health']
		tmp_eventvars['armor'] = event_var['armor']
		tmp_eventvars['dmg_armor'] = event_var['dmg_armor']
		tmp_eventvars['hitgroup'] = event_var['hitgroup']
		#victim
		tmp_eventvars['es_username'] = event_var['es_username']
		tmp_eventvars['es_steamid'] = event_var['es_steamid']
		tmp_eventvars['es_userteam'] = event_var['es_userteam']
		tmp_eventvars['es_userhealth'] = event_var['es_userhealth']
		tmp_eventvars['es_userarmor'] = event_var['es_userarmor']
		tmp_eventvars['es_userdeaths'] = event_var['es_userdeaths']
		tmp_eventvars['es_userkills'] = event_var['es_userkills']
		tmp_eventvars['es_userweapon'] = event_var['es_userweapon']
		tmp_eventvars['es_userdead'] = event_var['es_userdead']
		#attacker
		tmp_eventvars['es_attackername'] = event_var['es_attackername']
		tmp_eventvars['es_attackersteamid'] = event_var['es_attackersteamid']
		tmp_eventvars['es_attackerteam'] = event_var['es_attackerteam']
		tmp_eventvars['es_attackerhealth'] = event_var['es_attackerhealth']
		tmp_eventvars['es_attackerarmor'] = event_var['es_attackerarmor']
		tmp_eventvars['es_attackerdeaths'] = event_var['es_attackerdeaths']
		tmp_eventvars['es_attackerkills'] = event_var['es_attackerkills']
		tmp_eventvars['es_attackerweapon'] = event_var['es_attackerweapon']
		tmp_eventvars['es_attackerdead'] = event_var['es_attackerdead']
		wc_victim = playerlib.getPlayer(event_var['userid'])
		if wc_users.has_key(event_var['es_attackersteamid']):
			if wc_users[event_var['es_attackersteamid']]['voodoo'] == 1:
				wc_victim.set('health',int(wc_victim.get('health')) + int(event_var['dmg_health']))
				wc_victim.set('armor',int(wc_victim.get('armor')) + int(event_var['dmg_armor']))
				return 0
		if wc_users.has_key(event_var['es_steamid']):
			if wc_users[event_var['es_steamid']]['voodoo'] == 1:
				wc_victim.set('health',int(wc_victim.get('health')) + int(event_var['dmg_health']))
				wc_victim.set('armor',int(wc_victim.get('armor')) + int(event_var['dmg_armor']))
				return 0
		if event_var['es_steamid'] != 'BOT':
			wc_helmtest = check_helm(int(event_var['userid']))
			if event_var['hitgroup'] == '1' and wc_helmtest != 0:
				if wc_users[event_var['es_steamid']]['items'][2]['Helm of Excellence']['broken'] != 1:
					wc_victim.set('health',int(wc_victim.get('health')) + int(event_var['dmg_health']))
					wc_victim.set('armor',int(wc_victim.get('armor')) + int(event_var['dmg_armor']))
					wc_users[event_var['es_steamid']]['items'][2]['Helm of Excellence']['charges'] -= 1
					if wc_users[event_var['es_steamid']]['items'][2]['Helm of Excellence']['charges'] == 0:
						wc_users[event_var['es_steamid']]['items'][2]['Helm of Excellence']['broken'] = 1
						es.tell(event_var['userid'],'#green','Helm is Broken')
					return 0
			if event_var['es_attackersteamid'] != 'BOT':
				if wc_users[event_var['es_attackersteamid']]['mole'] != 0 and check_hasitem(int(event_var['userid']),'Mole Protectant') != 0:
					wc_victim.set('health',int(wc_victim.get('health')) + int(event_var['dmg_health']))
					es.msg('#green','blocked by mole protectant')
					return 0
			if not wc_users[event_var['es_steamid']]['disabled']:
				wc_users[event_var['es_steamid']]['object'].defensive(tmp_eventvars)
				wc_evaded = wc_users[event_var['es_steamid']]['evaded']
			if wc_evaded:
				wc_users[event_var['es_steamid']]['evaded'] = 0
				return 0
			check_items('player_hurt_victim',tmp_eventvars,event_var['userid'])
			wc_victim.refreshAttributes()
			if int(wc_victim.get('health')) <= wc_basehp:
				wc_kill = 1
		elif int(wc_victim.get('isdead')) != 0:
			wc_kill = 2
		if event_var['es_attackersteamid'] != 'BOT':
			if event_var['weapon'] != 'point_hurt' and event_var['weapon'] != 'env_explosion':
				if not wc_users[event_var['es_attackersteamid']]['disabled']:
					wc_users[event_var['es_attackersteamid']]['object'].offensive(tmp_eventvars,wc_kill)
				check_items('player_hurt_attacker',tmp_eventvars,int(event_var['attacker']))
				if event_var['es_steamid'] != 'BOT':
					wc_race = wc_users[event_var['es_steamid']]['race']
					wc_arace = wc_users[event_var['es_attackersteamid']]['race']
					if wc_users[event_var['es_steamid']][wc_race]['level'] > wc_users[event_var['es_attackersteamid']][wc_arace]['level']:
						wc_temp = wc_users[event_var['es_steamid']][wc_race]['level'] - wc_users[event_var['es_attackersteamid']][wc_arace]['level']
						give_xp(event_var['es_attackersteamid'],'silent',wc_temp)
		if wc_kill == 1:
			if not int(es.getplayerprop(event_var['userid'],"CBasePlayer.pl.deadflag")):
				wc_victim = playerlib.getPlayer(event_var['userid'])
				wc_victim.set('health',1)
				wc_tmp = dmg.get(int(event_var['attacker']))
				wc_headshots[event_var['userid']] = int(event_var['hitgroup'])
				wc_tmp.hurt(event_var['userid'],5,1,event_var['weapon'])
	#elif event_var['es_steamid'] != 'BOT':
		#wc_tmp = playerlib.getPlayer(event_var['userid'])
		#if int(wc_tmp.get('health')) <= wc_basehp:
			#wc_tmp.set('health',1)
			#wc_tmp2 = dmg.get(int(event_var['userid']))
			#wc_headshots[event_var['userid']] = int(event_var['hitgroup'])
			#wc_tmp2.hurt(event_var['userid'],5,1,event_var['weapon'])
	
def player_falldamage(event_var):
	if event_var['es_steamid'] != 'BOT':
		wc_tmp = playerlib.getPlayer(event_var['userid'])
		if int(wc_tmp.get('health')) <= wc_basehp:
			wc_tmp.set('health',1)
			wc_tmp2 = dmg.get(int(event_var['userid']))
			wc_headshots[event_var['userid']] = 0
			wc_tmp2.hurt(event_var['userid'],5,1,event_var['weapon'])
	
def player_death(event_var):
	global wc_pheonix_t, wc_pheonix_ct, wc_users
	tmp_eventvars = {}
	#event specific
	tmp_eventvars['userid'] = event_var['userid']
	tmp_eventvars['attacker'] = event_var['attacker']
	tmp_eventvars['weapon'] = event_var['weapon']
	tmp_eventvars['headshot'] = event_var['headshot']
	#victim
	tmp_eventvars['es_username'] = event_var['es_username']
	tmp_eventvars['es_steamid'] = event_var['es_steamid']
	tmp_eventvars['es_userteam'] = event_var['es_userteam']
	tmp_eventvars['es_userhealth'] = event_var['es_userhealth']
	tmp_eventvars['es_userarmor'] = event_var['es_userarmor']
	tmp_eventvars['es_userdeaths'] = event_var['es_userdeaths']
	tmp_eventvars['es_userkills'] = event_var['es_userkills']
	tmp_eventvars['es_userdead'] = event_var['es_userdead']
	#attacker
	if event_var['attacker'] != '0':
		tmp_eventvars['es_attackername'] = event_var['es_attackername']
		tmp_eventvars['es_attackersteamid'] = event_var['es_attackersteamid']
		tmp_eventvars['es_attackerteam'] = event_var['es_attackerteam']
		tmp_eventvars['es_attackerhealth'] = event_var['es_attackerhealth']
		tmp_eventvars['es_attackerarmor'] = event_var['es_attackerarmor']
		tmp_eventvars['es_attackerdeaths'] = event_var['es_attackerdeaths']
		tmp_eventvars['es_attackerkills'] = event_var['es_attackerkills']
		tmp_eventvars['es_attackerweapon'] = event_var['es_attackerweapon']
		tmp_eventvars['es_attackerdead'] = event_var['es_attackerdead']
	if event_var['es_steamid'] != 'BOT':
		if wc_weapontracking.has_key(event_var['userid']):
			wc_weapontracking[event_var['userid']]['spawn'] = 1
		if wc_users[event_var['es_steamid']]['vengeance'] == 0:
			if event_var['es_userteam'] == '2' and wc_pheonix_t > 0 and len(playerlib.getUseridList('#t,#alive')) > 0:
				es.server.queuecmd('est_spawn ' + event_var['userid'])
				wc_pheonix_t -= 1
			elif event_var['es_userteam'] == '3' and wc_pheonix_ct > 0 and len(playerlib.getUseridList('#ct,#alive')) > 0:
				es.server.queuecmd('est_spawn ' + event_var['userid'])
				wc_pheonix_ct -= 1
		else:
			es.server.queuecmd('est_spawn ' + event_var['userid'])
			wc_tmp = playerlib.getPlayer(event_var['userid'])
			gamethread.delayed(0.2,wc_tmp.set,('health',wc_users[event_var['es_steamid']]['vengeance'] + wc_basehp))
			wc_users[event_var['es_steamid']]['vengeance'] = 0
	if event_var['attacker'] != '0' and event_var['attacker'] != 'world' and event_var['attacker'] != 'world_spawn' and event_var['attacker'] != event_var['userid']:
		if event_var['es_attackersteamid'] != 'BOT':
			if event_var['weapon'] in wc_weaponlist:
				if int(event_var['headshot']) == 1:
					give_xp(event_var['es_attackersteamid'],'headshot')
				elif event_var['weapon'] == 'knife':
					give_xp(event_var['es_attackersteamid'],'player_knife')
				else:
					give_xp(event_var['es_attackersteamid'],'player_frag')
			else:
				give_xp(event_var['es_attackersteamid'],'player_skillfrag',0,event_var['weapon'])
			wc_users[event_var['es_attackersteamid']]['object'].attacker_death(event_var)
			check_items('attacker_death',tmp_eventvars,event_var['attacker'])
		if event_var['es_steamid'] != 'BOT':
			wc_users[event_var['es_steamid']]['object'].victim_death(event_var)
			check_items('victim_death',tmp_eventvars,event_var['userid'])
			wc_users[event_var['es_steamid']]['mole'] = 0
	elif event_var['es_steamid'] != 'BOT':
		check_items('victim_death',tmp_eventvars,event_var['userid'])
		if wc_users.has_key(event_var['es_steamid']):
			wc_users[event_var['es_steamid']]['ability'] = 0
			
def player_spawn(event_var):
	global wc_spawnlist, wc_weapontracking, wc_ctspawn, wc_tspawn
	wc_team = int(es.getplayerteam(event_var['userid']))
	if wc_team < 2:
		return 0
	wc_spawnorigin = es.getplayerprop(int(event_var['userid']),"CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_vecOrigin")
	wc_spawned = 0
	if wc_team == 2:
		for wc_tmp in wc_tspawn:
			if wc_tspawn[wc_tmp]["CBaseEntity.m_vecOrigin"] == wc_spawnorigin:
				wc_spawned = wc_tmp
		if wc_tspawn.has_key(wc_spawned):
			#gamethread.delayed(0.2,del_spawn,('wc_tspawn',wc_spawned))
			del wc_tspawn[wc_spawned]
	else:
		for wc_tmp in wc_ctspawn:
			if wc_ctspawn[wc_tmp]["CBaseEntity.m_vecOrigin"] == wc_spawnorigin:
				wc_spawned = wc_tmp
		if wc_ctspawn.has_key(wc_spawned):
			#gamethread.delayed(0.2,del_spawn,('wc_ctspawn',wc_spawned))
			del wc_ctspawn[wc_spawned]
	if event_var['es_steamid'] != 'BOT' and event_var['es_steamid'] != None and event_var['es_steamid'] != 'STEAM_ID_PENDING':
		if not wc_weapontracking.has_key(event_var['userid']):
			if int(es.getplayerteam(event_var['userid'])) == 3:
				wc_weapontracking[event_var['userid']] = {'primary': None, 'pistol': 'weapon_usp', 'spawn': 0}
			else:
				wc_weapontracking[event_var['userid']] = {'primary': None, 'pistol': 'weapon_glock', 'spawn': 0}
		if wc_users.has_key(event_var['es_steamid']):
			setup_player(event_var['userid'])
			wc_users[event_var['es_steamid']]['object'].spawn()
			spawn_items(event_var['userid'])
			show_users_xp(event_var['userid'])
		#wc_spawnlist[event_var['userid']] = event_var['es_steamid']
		#if len(wc_spawnlist) == 1:
			#wc_handle_spawn(event_var['userid'])

def player_team(event_var):
	if int(event_var['team']) > 1:
		if event_var['es_steamid'] != 'BOT':
			if event_var['es_steamid'] != 'STEAM_ID_PENDING':
				if event_var['es_steamid'] != None:
					if wc_skills.has_key(event_var['es_steamid']):
						init_player(event_var['userid'])
					else:
						create_new_player(event_var['userid'])
				else:
					es.changeteam(event_var['userid'],1)
			else:
				es.changeteam(event_var['userid'],1)
			
def player_disconnect(event_var):
	global wc_users, wc_wardlist
	if event_var['networkid'] != 'BOT':
		wc_userid = int(event_var['userid'])
		if wc_users.has_key(event_var['networkid']):
			set_in_db(event_var['networkid'])
			del wc_users[event_var['networkid']]
		if wc_wardlist.has_key(wc_userid):
			for wc_tmp in wc_wardlist[wc_userid].keys():
				es.server.queuecmd('est_box_remove ' + wc_tmp)
			del wc_wardlist[wc_userid]
			
def bomb_planted(event_var):
	if wc_users.has_key(event_var['es_steamid']):
		give_xp(event_var['es_steamid'],'bomb_planted')
	
def bomb_defused(event_var):
	wc_playerlist = playerlib.getUseridList('#ct,#human')
	if int(event_var['userid']) in wc_playerlist:
		wc_playerlist.remove(int(event_var['userid']))
	for wc_tmp in wc_playerlist:
		if wc_users.has_key(es.getplayersteamid(wc_tmp)):
			give_xp(es.getplayersteamid(wc_tmp),'bomb_defused_team')
	if wc_users.has_key(event_var['es_steamid']):
		give_xp(event_var['es_steamid'],'bomb_defused')
	
def bomb_exploded(event_var):
	wc_playerlist = playerlib.getUseridList('#t,#human')
	for wc_tmp in wc_playerlist:
		if wc_users.has_key(es.getplayersteamid(wc_tmp)):
			give_xp(es.getplayersteamid(wc_tmp),'bomb_exploded')
	
def hostage_rescued(event_var):
	if wc_users.has_key(event_var['es_steamid']):
		give_xp(event_var['es_steamid'],'hostage_rescued')
	
def hostage_rescued_all(event_var):
	wc_tmplist = playerlib.getUseridList('#ct,#human')
	if len(wc_tmplist) > 0:
		for wc_tmp in wc_tmplist:
			wc_steamid = es.getplayersteamid(wc_tmp)
			if wc_users.has_key(wc_steamid):
				give_xp(wc_steamid,'hostage_rescued_all')
	
def round_start(event_var):
	global wc_ult_enabled, wc_timers, wc_headshots, wc_users, wc_wardlist
	wc_ult_enabled = 0
	wc_timers['ult_activate'] = '0'
	wc_tmpdelay = es.ServerVar("mp_freezetime")
	wc_delay = float(wc_tmpdelay) + wc_ult_delay
	gamethread.delayedname(wc_delay,'ult_activate',wc_ultimate_activate,1)
	wc_delay = float(wc_tmpdelay) + 0.5
	wc_timers['move_moles'] = '0'
	gamethread.delayedname(wc_delay,'move_moles',move_moles,)
	wc_headshots = {}
	wc_tmplist = playerlib.getUseridList('#human')
	wc_tmpsteamlist = {}
	for wc_tmp in wc_tmplist:
		wc_tmpsteam = es.getplayersteamid(wc_tmp)
		wc_tmpsteamlist[wc_tmpsteam] = 1
	for wc_tmp in wc_users.keys():
		if not wc_tmp in wc_tmpsteamlist:
			del wc_users[wc_tmp]
	if len(wc_wardlist) > 0:
		for wc_tmp in wc_wardlist.keys():
			for wc_wardname in wc_wardlist[wc_tmp]:
				es.server.queuecmd('est_box_remove ' + wc_wardname)
	wc_wardlist = {}
	wc_hostagelist = es.createentitylist('hostage_entity')
	if len(wc_hostagelist) > 0:
		for wc_tmp in wc_hostagelist:
			es.setindexprop(wc_tmp,'CHostage.m_iHealth',9999)
	set_bombsites()
	
def round_end(event_var):
	global wc_pheonix_t, wc_pheonix_ct, wc_ctspawn, wc_tspawn, wc_users, wc_ult_enabled
	stop_timers()
	for wc_tmp in wc_users.keys():
		if wc_skills.has_key(wc_tmp):
			set_in_db(wc_tmp)
	wc_file = open(es.getAddonPath('wcs2') + "/wc_skills.db",'wb')
	pickle.dump(wc_skills,wc_file)
	wc_file.close()
	wc_pheonix_t = 0
	wc_pheonix_ct = 0
	wc_ult_enabled = 0
	wc_tspawn = {}
	wc_ctspawn = {}
	wc_nadelist = {}
	wc_tspawn = es.createentitylist('info_player_terrorist')
	wc_ctspawn = es.createentitylist('info_player_counterterrorist')
	for wc_tmp in wc_users:
		wc_users[wc_tmp]['spawned'] = 0
		wc_users[wc_tmp]['mole'] = 0
	
def est_box_trigger(event_var):
	global wc_users, wc_timers
	if int(es.getplayerteam(event_var['userid'])) > 1:
		if len(wc_bombsites) > 0:
			wc_steamid = es.getplayersteamid(event_var['userid'])
			if wc_steamid != 'BOT':
				if wc_bombsites.has_key(event_var['boxname']):
					if wc_users.has_key(wc_steamid):
						wc_timername = 'bombsite' + str(event_var['userid'])
						wc_users[wc_steamid]['bombsite'] = 1
						if wc_timers.has_key(wc_timername):
							gamethread.cancelDelayed(wc_timername)
						else:
							wc_timers[wc_timername] = wc_steamid
						gamethread.delayedname(0.5,wc_timername,set_bombsite_off,event_var['userid'])
						return 0
		if len(wc_wardlist) > 0:
			for wc_tmp in wc_wardlist:
				if wc_wardlist[wc_tmp].has_key(event_var['boxname']):
					wc_dmg = dmg.get(wc_tmp)
					wc_dmg.hurt(event_var['userid'],5,1,"serpent_ward")
					es.server.queuecmd('est_fade ' + str(wc_tmp) + ' 0 0.2 0 255 0 255 126')
					return 0
	
def del_spawn(wc_spawn,wc_index):
	global wc_tspawn, wc_ctspawn
	if wc_spawn == 'wc_tspawn':
		if wc_tspawn.has_key(wc_index):
			del wc_tspawn[wc_index]
	else:
		if wc_ctspawn.has_key(wc_index):
			del wc_ctspawn[wc_index]

# core functions:
def wc_death():
	global wc_headshots
	es.server.cmd('est_geteventinfo wc_weapon_return weapon')
	wc_tmpstring = es.getString('wc_weapon_return')
	if wc_tmpstring == 'point_hurt':
		#es.set('wc_victim_return','0')
		es.server.cmd('est_geteventinfo wc_victim_return userid')
		wc_victim = es.getInt('wc_victim_return')
		wc_tmpweapon = dmg.dmg_check_attacks(wc_victim)
		if wc_tmpweapon != '0':
			es.server.cmd('est_seteventinfo weapon ' + wc_tmpweapon)
			dmg.dmg_remove_attacks(wc_victim)
			if wc_tmpweapon in wc_weaponlist:
				if wc_headshots.has_key(str(wc_victim)):
					if int(wc_headshots[str(wc_victim)]) == 1:
						es.server.cmd('est_seteventinfo headshot 1')
					del wc_headshots[str(wc_victim)]
	elif wc_tmpstring == 'env_explosion':
		es.server.cmd('est_seteventinfo weapon suicide_explosion')
			
def set_bombsites():
	global wc_bombsites
	if len(wc_bombsites) > 0:
		for wc_tmp in wc_bombsites:
			es.server.queuecmd('est_box_remove ' + wc_tmp)
	wc_bombsites = {}
	wc_tmplist = es.createentitylist('func_bomb_target')
	if len(wc_tmplist) > 0:
		for wc_tmp in wc_tmplist:
			wc_sitename = 'bombsite' + str(wc_tmp)
			wc_startvec = wc_tmplist[wc_tmp]['CBaseEntity.m_Collision.m_vecMins']
			wc_endvec = wc_tmplist[wc_tmp]['CBaseEntity.m_Collision.m_vecMaxs']
			es.server.queuecmd('est_box_trigger #ct!d!b ' + wc_sitename + ' ' + wc_startvec + ' ' + wc_endvec + ' 0.1')
			wc_bombsites[wc_sitename] = 1
			
def set_bombsite_off(wc_userid):
	global wc_users, wc_timers
	wc_timername = 'bombsite' + str(wc_userid)
	if wc_timers.has_key(wc_timername):
		del wc_timers[wc_timername]
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_users[wc_steamid]['bombsite'] = 0
			
def wc_rings(wc_userid):
	global wc_users
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_users[wc_steamid]['race'] != 'Shadow Hunter':
		wc_cash = int(es.getplayerprop(wc_userid,"CCSPlayer.m_iAccount"))
		tmp_total = wc_users[wc_steamid]['rings']
		while tmp_total < wc_items_list[2]['Ring of Regeneration']['total']:
			if wc_cash >= wc_items_list[2]['Ring of Regeneration']['price']:
				if tmp_total == 0:
					wc_users[wc_steamid]['items'][2]['Ring of Regeneration'] = {}
					wc_users[wc_steamid]['items'][2]['Ring of Regeneration']['object'] = wc_items_list[2]['Ring of Regeneration']['call'](wc_userid)
				wc_users[wc_steamid]['items'][2]['Ring of Regeneration']['object'].item_purchased(2)
				wc_cash = int(es.getplayerprop(wc_userid,"CCSPlayer.m_iAccount"))
				tmp_total = wc_users[wc_steamid]['rings']
			else:
				tmp_total = wc_items_list[2]['Ring of Regeneration']['total']
			
def wc_sayfilter(wc_userid, wc_text, wc_teamonly):
	global wc_users
	wc_tmp = playerlib.getPlayer(wc_userid)
	wc_steamid = es.getplayersteamid(int(wc_userid))
	wc_text = wc_text.strip('"')
	if wc_users.has_key(wc_steamid):
		if wc_text == 'changerace':
			if wc_tmp.get('isdead') == 1:
				wc_Race_Menu(wc_userid)
			else:
				es.tell(int(wc_userid),'#green','You must be dead to Change Race.')
			return (0, wc_text, wc_teamonly)	
		elif wc_text == 'resetskills':
			if wc_tmp.get('isdead') == 1:
				reset_skills(wc_steamid)
				wc_Skill_Menu(wc_userid)
			else:
				es.tell(int(wc_userid),'#green','You must be dead to Reset Skills.')
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'spendskills':
			if wc_tmp.get('isdead') == 1:
				wc_Skill_Menu(wc_userid)
			else:
				es.tell(int(wc_userid),'#green','You must be dead to Spend Skill Points.')
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'shopmenu':
			wc_Main_Shop_Menu(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'test_error':
			es.server.queuecmd('est_effect_03 blah')
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'shopmenu1':
			wc_Shop_Menu(wc_userid,1)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'shopmenu2':
			wc_Shop_Menu(wc_userid,2)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'iteminfo':
			wc_Main_ItemInfo(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'iteminfo1':
			wc_Item_Info(wc_userid,1)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'iteminfo2':
			wc_Item_Info(wc_userid,2)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'skillsinfo':
			wc_Skills_Info(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'raceinfo':
			wc_Race_Info(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'playerinfo':
			wc_Player_Info(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'showskills':
			playerSelected(wc_userid,es.getplayersteamid(wc_userid))
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'showitems':
			wc_Show_Items(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'dropitem':
			wc_Drop_Item(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'help' or wc_text == 'wcs' or wc_text == 'wc3help' or wc_text == 'wcshelp' or wc_text == 'wcs2':
			wc_Help_Menu(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'showxp':
			show_users_xp(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'rings':
			wc_rings(wc_userid)
			return (0, wc_text, wc_teamonly)
		elif wc_text == '!cat':
			if wc_users[wc_steamid]['items'][2].has_key('Amulet of the Cat'):
				if wc_users[wc_steamid]['items'][2]['Amulet of the Cat']['set'] == 0:
					wc_users[wc_steamid]['items'][2]['Amulet of the Cat']['object'].player_passive()
				else:
					wc_users[wc_steamid]['items'][2]['Amulet of the Cat']['set'] = 0
					es.setplayerprop(wc_userid,"CBasePlayer.m_fFlags","1")
			return (0, wc_text, wc_teamonly)
		elif wc_text == 'resetallmyxp':
			wc_tmp2 = -1 * get_users_xp(wc_steamid)
			give_xp(wc_steamid,'silent',wc_tmp2)
			return (0, wc_text, wc_teamonly)
		else:
			return (wc_userid, wc_text, wc_teamonly)
	else:
		return (wc_userid, wc_text, wc_teamonly)
	
def wc_Help_Menu(wc_userid):
	popuplib.removeall(wc_userid)
	wc_tmpplayer = playerlib.getPlayer(wc_userid)
	wc_dead = wc_tmpplayer.get('isdead')
	if popuplib.exists('Help_Menu ' + str(wc_userid)):
		#popuplib.close('Help_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Help_Menu ' + str(wc_userid))
	WC_HelpMenu = popuplib.easymenu('Help_Menu ' + str(wc_userid), 'wc_choice', helpSelected)
	WC_HelpMenu.settitle('These are the Commands:')
	WC_HelpMenu.addoption('changerace','changerace - Only when dead\nNOTE: This will clear your items',wc_dead)
	WC_HelpMenu.addoption('spendskills','spendskills - Only when dead',wc_dead)
	WC_HelpMenu.addoption('resetskillls','resetskillls - Only when dead',wc_dead)
	WC_HelpMenu.addoption('showskills','showskills')
	WC_HelpMenu.addoption('skillsinfo','skillsinfo')
	WC_HelpMenu.addoption('playerinfo','playerinfo')
	WC_HelpMenu.addoption('raceinfo','raceinfo')
	WC_HelpMenu.addoption('showxp','showxp')
	WC_HelpMenu.addoption('shopmenu','shopmenu / shopmenu1 / shopmenu2')
	WC_HelpMenu.addoption('showitems','showitems')
	WC_HelpMenu.addoption('dropitem','dropitem')
	WC_HelpMenu.addoption('iteminfo','iteminfo / iteminfo1 / iteminfo2')
	WC_HelpMenu.addoption('rings','rings - buys up to 5 rings')
	WC_HelpMenu.send(wc_userid)

def helpSelected(wc_userid,wc_choice,wc_menuname='0'):
	wc_tmp = playerlib.getPlayer(wc_userid)
	wc_steamid = es.getplayersteamid(int(wc_userid))
	if wc_choice == 'changerace':
		if wc_tmp.get('isdead') == 1:
			wc_Race_Menu(wc_userid)
		else:
			es.tell(int(wc_userid),'#green','You must be dead to Change Race.')
	elif wc_choice == 'spendskills':
		if wc_tmp.get('isdead') == 1:
			wc_Skill_Menu(wc_userid)
		else:
			es.tell(int(wc_userid),'#green','You must be dead to Spend Skill Points.')
	elif wc_choice == 'resetskills':
		if wc_tmp.get('isdead') == 1:
			reset_skills(wc_steamid)
			wc_Skill_Menu(wc_userid)
		else:
			es.tell(int(wc_userid),'#green','You must be dead to Reset Skills.')
	elif wc_choice == 'showskills':
		playerSelected(wc_userid,wc_steamid)
	elif wc_choice == 'skillsinfo':
		wc_Skills_Info(wc_userid)
	elif wc_choice == 'playerinfo':
		wc_Player_Info(wc_userid)
	elif wc_choice == 'raceinfo':
		wc_Race_Info(wc_userid)
	elif wc_choice == 'showxp':
		show_users_xp(wc_userid)
	elif wc_choice == 'shopmenu':
		wc_Main_Shop_Menu(wc_userid)
	elif wc_choice == 'showitems':
		wc_Show_Items(wc_userid)
	elif wc_choice == 'dropitem':
		wc_Drop_Item(wc_userid)
	elif wc_choice == 'iteminfo':
		wc_Main_ItemInfo(wc_userid)
	elif wc_choice == 'rings':
		wc_rings(wc_userid)
	
def wc_Show_Items(wc_userid):
	popuplib.removeall(wc_userid)
	if popuplib.exists('Show_Items_Menu ' + str(wc_userid)):
		#popuplib.close('Show_Items_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Show_Items_Menu ' + str(wc_userid))
	WC_showItemsMenu = popuplib.easymenu('Show_Items_Menu ' + str(wc_userid), 'wc_choice', None)
	WC_showItemsMenu.settitle('These are your Items:')
	wc_steamid = es.getplayersteamid(wc_userid)
	for wc_slot in wc_users[wc_steamid]['items'].keys():
		if len(wc_users[wc_steamid]['items'][wc_slot].keys()) > 0:
			for wc_itemname in wc_users[wc_steamid]['items'][wc_slot].keys():
				WC_showItemsMenu.addoption(wc_itemname,'Slot ' + str(wc_slot) + ': ' + wc_itemname + '(' + str(wc_users[wc_steamid]['items'][wc_slot][wc_itemname]['total']) + '/' + str(wc_items_list[wc_slot][wc_itemname]['total']) + ')')
		else:
			WC_showItemsMenu.addoption('None','Slot ' + str(wc_slot) + ': No Items',0)
	WC_showItemsMenu.send(wc_userid)
	
def wc_Drop_Item(wc_userid):
	popuplib.removeall(wc_userid)
	if popuplib.exists('Drop_Item_Menu ' + str(wc_userid)):
		#popuplib.close('Drop_Item_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Drop_Item_Menu ' + str(wc_userid))
	WC_dropItemMenu = popuplib.easymenu('Drop_Item_Menu ' + str(wc_userid), 'wc_choice', wc_DropItem)
	WC_dropItemMenu.settitle('Select an Item to drop:')
	wc_steamid = es.getplayersteamid(wc_userid)
	for wc_slot in wc_users[wc_steamid]['items'].keys():
		if len(wc_users[wc_steamid]['items'][wc_slot].keys()) > 0:
			for wc_itemname in wc_users[wc_steamid]['items'][wc_slot].keys():
				WC_dropItemMenu.addoption((wc_slot,wc_itemname),'Slot ' + str(wc_slot) + ': ' + wc_itemname + '(' + str(wc_users[wc_steamid]['items'][wc_slot][wc_itemname]['total']) + '/' + str(wc_items_list[wc_slot][wc_itemname]['total']) + ')')
		else:
			WC_dropItemMenu.addoption('None','Slot ' + str(wc_slot) + ': No Items',0)
	WC_dropItemMenu.send(wc_userid)
	
def wc_DropItem(wc_userid,wc_choice,wc_menuname='0'):
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_users[wc_steamid]['items'][wc_choice[0]].has_key(wc_choice[1]):
		wc_users[wc_steamid]['items'][wc_choice[0]][wc_choice[1]]['object'].drop_item()
		
def wc_Player_Info(wc_userid):
	popuplib.removeall(wc_userid)
	wc_counter = 0
	if popuplib.exists('Player_Menu ' + str(wc_userid)):
		#popuplib.close('Player_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Player_Menu ' + str(wc_userid))
	WC_PlayerInfo = popuplib.easymenu('Player_Menu ' + str(wc_userid), 'wc_choice', playerSelected)
	WC_PlayerInfo.settitle('Select a Player to See Their Skills:')
	wc_tmplist = playerlib.getUseridList('#human')
	for wc_tmp in wc_tmplist:
		wc_tmpsteam = es.getplayersteamid(wc_tmp)
		if wc_users.has_key(wc_tmpsteam):
			# and int(wc_tmp) != int(wc_userid)
			wc_race = wc_users[wc_tmpsteam]['race']
			WC_PlayerInfo.addoption(wc_tmpsteam, es.getplayername(wc_tmp) + ' - ' + wc_race + ' (' + str(wc_users[wc_tmpsteam][wc_race]['level']) + ')')
			wc_counter += 1
	if wc_counter > 0:
		WC_PlayerInfo.send(wc_userid)
	else:
		es.tell(wc_userid,'#green','No one to display')
		popuplib.delete('Player_Menu' + str(wc_userid))
		
def playerSelected(wc_userid,wc_choice,wc_menuname='0'):
	popuplib.removeall(wc_userid)
	if wc_choice in wc_users:
		wc_tmpid = es.getplayersteamid(wc_userid)
		wc_race = wc_users[wc_choice]['race']
		if popuplib.exists('User_Menu ' + str(wc_userid)):
			#popuplib.close('User_Menu ' + str(wc_userid),int(wc_userid))
			popuplib.delete('User_Menu ' + str(wc_userid))
		WC_UserInfo = popuplib.easymenu('User_Menu ' + str(wc_userid), 'wc_choice', None)
		if wc_choice == wc_tmpid:
			WC_UserInfo.settitle('Your Current Skills:')
		else:
			WC_UserInfo.settitle('Their Current Skills:')
		i = 0
		for wc_tmp in wc_races_list[wc_race]['return']:
			WC_UserInfo.addoption(wc_tmp, wc_races_list[wc_race]['display'][i] + ' (' + str(wc_users[wc_choice][wc_race][wc_tmp]) + ')')
			i += 1
		WC_UserInfo.send(wc_userid)
	else:
		es.tell(wc_userid,'#green','Player is no longer on the server')

def wc_Skills_Info(wc_userid,wc_race='0'):
	wc_steamid = es.getplayersteamid(wc_userid)
	popuplib.removeall(wc_userid)
	if wc_race == '0' or not wc_race in wc_races_list:
		wc_race = wc_users[wc_steamid]['race']
	if popuplib.exists('Info_Menu ' + str(wc_userid)):
		#popuplib.close('Info_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Info_Menu ' + str(wc_userid))
	WC_InfoMenu = popuplib.easymenu('Info_Menu ' + str(wc_userid), 'wc_choice', None)     
	WC_InfoMenu.settitle('Skills Info:') 
	i = 0
	count = 0
	for wc_skillname in wc_races_list[wc_race]['display']: 
		count += 1
		if count == 4:
			WC_InfoMenu.addoption(' ',' ',0)
			count = 1
		WC_InfoMenu.addoption(' ',wc_skillname)
		WC_InfoMenu.addoption(' ',wc_races_list[wc_race]['info'][i],0)
		i += 1
	WC_InfoMenu.send(wc_userid)
	
def wc_Race_Info(wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	popuplib.removeall(wc_userid)
	if popuplib.exists('RaceInfo_Menu ' + str(wc_userid)):
		#popuplib.close('RaceInfo_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('RaceInfo_Menu ' + str(wc_userid))
	WC_RaceInfo = popuplib.easymenu('RaceInfo_Menu ' + str(wc_userid), 'wc_choice', raceInfoSelected)
	WC_RaceInfo.settitle('Select a Race:')
	for wc_racename in wc_racelist: 
		WC_RaceInfo.addoption(wc_racename, wc_racename)
	WC_RaceInfo.send(wc_userid)
	
def raceInfoSelected(wc_userid,wc_choice,wc_menuname):
	gamethread.delayed(0.2,wc_Skills_Info,(wc_userid,wc_choice))
	
def wc_Race_Menu(wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	popuplib.removeall(wc_userid)
	if popuplib.exists('Race_Menu ' + str(wc_userid)):
		#popuplib.close('Race_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Race_Menu ' + str(wc_userid))
	WC_RaceMenu = popuplib.easymenu('Race_Menu ' + str(wc_userid), 'wc_choice', raceSelected)     
	WC_RaceMenu.settitle('Select a Race:') 
	for wc_racename in wc_racelist: 
		WC_RaceMenu.addoption(wc_racename, wc_racename + ' (' + str(wc_users[wc_steamid][wc_racename]['level']) +')')
	WC_RaceMenu.send(wc_userid)

def raceSelected(wc_userid,wc_choice,wc_menuname):
	wc_tmp = playerlib.getPlayer(wc_userid)
	if wc_tmp.get('isdead'):
		setup_player(wc_userid)
		set_race(wc_userid,wc_choice)
	else:
		es.tell(wc_userid,'#green','You cannot changerace while alive')

def wc_Skill_Menu(wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_race = get_race(wc_steamid)
	popuplib.removeall(wc_userid)
	if popuplib.exists('Skill_Menu ' + str(wc_userid)):
		#popuplib.close('Skill_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Skill_Menu ' + str(wc_userid))
	wc_SkillMenu = popuplib.easymenu('Skill_Menu ' + str(wc_userid),'wc_choice', skillSelected)
	wc_SkillMenu.settitle('Select a Skill:')
	i = 0
	for wc_tmp in wc_races_list[wc_race]['return']:
		skillname = wc_races_list[wc_race]['display'][i]
		skilldesc = '\n' + wc_races_list[wc_race]['info'][i]
		i += 1
		if wc_races_list[wc_race]['skills'][wc_tmp] == 'skill' or wc_races_list[wc_race]['skills'][wc_tmp] == 'ability':
			if wc_users[wc_steamid][wc_race][wc_tmp] >= wc_max_skill_lvl:
				wc_state = 0
			else:
				wc_state = 1
			wc_SkillMenu.addoption(wc_tmp,skillname + ' (' + str(wc_users[wc_steamid][wc_race][wc_tmp]) + ')',wc_state)
		else:
			if wc_users[wc_steamid][wc_race]['level'] >= wc_ult_level:
				if wc_users[wc_steamid][wc_race][wc_tmp] >= wc_max_ult_lvl:
					wc_state = 0
				else:
					wc_state = 1
				wc_SkillMenu.addoption(wc_tmp,skillname + ' (' + str(wc_users[wc_steamid][wc_race][wc_tmp]) + ')',wc_state)
	wc_SkillMenu.send(wc_userid)
	
def skillSelected(wc_userid,wc_choice,wc_menuname):
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_race = get_race(wc_steamid)
	wc_total = wc_users[wc_steamid][wc_race]['level']
	for wc_tmp in wc_races_list[wc_race]['skills']:
		wc_total -= wc_users[wc_steamid][wc_race][wc_tmp]
	if wc_total > 0:
		add_skill_lvl(wc_steamid,wc_choice,1)
		wc_total -= 1
		if wc_total > 0:
			wc_Skill_Menu(wc_userid)
	
def wc_Shop_Menu(wc_userid,menu_num,menu_name='0'):
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_race = get_race(wc_steamid)
	wc_menu_num = int(menu_num)
	popuplib.removeall(wc_userid)
	if popuplib.exists('Shop_Menu ' + str(wc_userid)):
		#popuplib.close('Shop_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Shop_Menu ' + str(wc_userid))
	wc_ShopMenu = popuplib.easymenu('Shop_Menu ' + str(wc_userid),'wc_choice', itemSelected)
	wc_ShopMenu.settitle('Select an Item:')
	wc_cash = int(es.getplayerprop(wc_userid,"CCSPlayer.m_iAccount"))
	for wc_tmp in wc_items_list[wc_menu_num]['Menu']:
		wc_state = 0
		if wc_items_list[wc_menu_num][wc_tmp]['price'] <= wc_cash:
			if wc_users[wc_steamid]['items'][wc_menu_num].has_key(wc_tmp):
				if wc_users[wc_steamid]['items'][wc_menu_num][wc_tmp]['total'] < wc_items_list[wc_menu_num][wc_tmp]['total'] or len(wc_users[wc_steamid]['items'][wc_menu_num]) < wc_max_items_each:
					wc_state = 1
			elif len(wc_users[wc_steamid]['items'][wc_menu_num]) < wc_max_items_each:
				wc_state = 1
		wc_ShopMenu.addoption((wc_menu_num,wc_tmp),wc_tmp + ' $' + str(wc_items_list[wc_menu_num][wc_tmp]['price']),wc_state)
	wc_ShopMenu.send(wc_userid)
	
def wc_Item_Info(wc_userid,menu_num,menu_name='0'):
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_race = get_race(wc_steamid)
	wc_menu_num = int(menu_num)
	popuplib.removeall(wc_userid)
	if popuplib.exists('ItemInfo_Menu ' + str(wc_userid)):
		#popuplib.close('Shop_Menu ' + str(wc_userid),int(wc_userid))
		popuplib.delete('ItemInfo_Menu ' + str(wc_userid))
	wc_InfoMenu = popuplib.easymenu('ItemInfo1_Menu ' + str(wc_userid),'wc_choice', None)
	wc_InfoMenu.settitle('Items are:')
	i = 0
	for wc_tmp in wc_items_list[wc_menu_num]['Menu']:
		i += 1
		if i == 4:
			wc_InfoMenu.addoption(wc_tmp,' ',0)
			i = 1
		wc_InfoMenu.addoption(wc_tmp,wc_tmp)
		wc_InfoMenu.addoption(wc_tmp,wc_items_list[wc_menu_num][wc_tmp]['info'],0)
	wc_InfoMenu.send(wc_userid)
	
def wc_Main_ItemInfo(wc_userid):
	popuplib.removeall(wc_userid)
	if popuplib.exists('Shop_Info_Main ' + str(wc_userid)):
		#popuplib.close('Shop_Menu_Main ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Shop_Info_Main ' + str(wc_userid))
	wc_ShopInfoMenu = popuplib.easymenu('Shop_Info_Main ' + str(wc_userid),'wc_choice', wc_Item_Info)
	wc_ShopInfoMenu.settitle('Select a Shop Menu:')
	for wc_tmp in wc_items_list:
		wc_ShopInfoMenu.addoption(wc_tmp,'Shop Menu ' + str(wc_tmp),1)
	wc_ShopInfoMenu.send(wc_userid)
	
def wc_Main_Shop_Menu(wc_userid):
	popuplib.removeall(wc_userid)
	if popuplib.exists('Shop_Menu_Main ' + str(wc_userid)):
		#popuplib.close('Shop_Menu_Main ' + str(wc_userid),int(wc_userid))
		popuplib.delete('Shop_Menu_Main ' + str(wc_userid))
	wc_ShopMenu = popuplib.easymenu('Shop_Menu_Main ' + str(wc_userid),'wc_choice', wc_Shop_Menu)
	wc_ShopMenu.settitle('Select a Shop Menu:')
	for wc_tmp in wc_items_list:
		wc_ShopMenu.addoption(wc_tmp,'Shop Menu ' + str(wc_tmp),1)
	wc_ShopMenu.send(wc_userid)
	
def itemSelected(wc_userid,wc_choice,wc_menuname):
	global wc_users
	#wc_menu_num = int(wc_menuname.replace('Shop_Menu ', ''))
	#es.msg('#green',str(wc_menu_num))
	wc_steamid = es.getplayersteamid(wc_userid)
	if not wc_users[wc_steamid]['items'][wc_choice[0]].has_key(wc_choice[1]):
		wc_users[wc_steamid]['items'][wc_choice[0]][wc_choice[1]] = {}
		wc_users[wc_steamid]['items'][wc_choice[0]][wc_choice[1]]['object'] = wc_items_list[wc_choice[0]][wc_choice[1]]['call'](wc_userid)
	wc_users[wc_steamid]['items'][wc_choice[0]][wc_choice[1]]['object'].item_purchased(wc_choice[0])
	
def wc_handle_spawn(wc_userid):
	global wc_spawnlist
	wc_steamid = wc_spawnlist[wc_userid]
	if wc_users.has_key(wc_steamid) and wc_steamid != 'BOT':
		setup_player(wc_userid)
		wc_users[wc_steamid]['object'].spawn()
		spawn_items(wc_userid)
		show_users_xp(wc_userid)
	else:
		es.changeteam(wc_userid,1)
	if wc_spawnlist.has_key(wc_userid):
		del wc_spawnlist[wc_userid]
	wc_nextspawn()
	
def wc_nextspawn():
	if len(wc_spawnlist) > 0:
		for wc_tmp in wc_spawnlist.keys():
			wc_handle_spawn(wc_tmp)
			return 0
		
# this gets run all the time to reset values on spawn
def setup_player(wc_userid):
	global wc_users
	wc_steamid = es.getplayersteamid(wc_userid)
	es.server.queuecmd('es_fire ' + str(wc_userid) + ' !self addoutput \"gravity 1.0\"')
	wc_users[wc_steamid]['maxhp'] = 100 + wc_basehp
	wc_users[wc_steamid]['gravity'] = 1.0
	wc_users[wc_steamid]['speed'] = 1.0
	wc_users[wc_steamid]['regen'] = 0
	wc_users[wc_steamid]['reflect'] = 0
	wc_users[wc_steamid]['helm'] = 0
	wc_users[wc_steamid]['protectant'] = 0
	wc_users[wc_steamid]['ability'] = 0
	wc_users[wc_steamid]['disabled'] = 0
	wc_users[wc_steamid]['evaded'] = 0
	wc_users[wc_steamid]['blink'] = 0
	wc_users[wc_steamid]['ultimate'] = -1
	wc_users[wc_steamid]['rings'] = 0
	wc_users[wc_steamid]['bombsite'] = 0
	wc_users[wc_steamid]['voodoo'] = 0
	wc_users[wc_steamid]['vengeance'] = 0
	wc_tmp = playerlib.getPlayer(int(wc_userid))
	wc_tmp.set('health',wc_users[wc_steamid]['maxhp'])

# used for giving all xp
def give_xp(wc_steamid,wc_reason,wc_ammount=0,wc_weapon="0"):
	global wc_users
	if wc_users.has_key(wc_steamid):
		wc_tmpammount = 0
		wc_race = get_race(wc_steamid)
		if not wc_ammount and wc_xp.has_key(wc_reason):
			wc_tmpammount = wc_xp[wc_reason]['ammount'] + int(wc_users[wc_steamid][wc_race]['level'] / 2)
			wc_tmpid = es.getuserid(wc_steamid)
			if wc_xp.has_key(wc_reason):
				if wc_xp[wc_reason]['reason'] != 'silent' and wc_weapon == '0':
					es.tell(wc_tmpid,'#multi','#lightgreen[#greenXP#lightgreen]#green You gained %d XP for %s' % (wc_tmpammount, wc_xp[wc_reason]['reason']))
				elif wc_xp[wc_reason]['reason'] != 'silent' and wc_weapon != '0':
					if wc_races_list[wc_users[wc_steamid]['race']]['skills'].has_key(wc_weapon):
						wc_skillwep = wc_races_list[wc_users[wc_steamid]['race']]['display'][wc_races_list[wc_users[wc_steamid]['race']]['return'].index(wc_weapon)]
					else:
						wc_skillwep = wc_weapon
					es.tell(wc_tmpid,'#multi','#lightgreen[#greenXP#lightgreen]#green You gained %d XP for %s with %s' % (wc_tmpammount, wc_xp[wc_reason]['reason'], wc_skillwep))
		elif wc_ammount:
			wc_tmpammount = wc_ammount + int(wc_users[wc_steamid][wc_race]['level'] / 2)
			wc_tmpid = es.getuserid(wc_steamid)
			if wc_reason != 'silent':
				es.tell(wc_tmpid,'#multi','#lightgreen[#greenXP#lightgreen]#green You have gained %d XP for %s' % (wc_tmpammount, wc_reason))
		add_users_xp(wc_steamid,wc_tmpammount)
		# levels
		wc_clevel = get_race_lvl(wc_steamid)
		while wc_users[wc_steamid][wc_race]['xp'] >= get_xp_limit(wc_clevel):
			add_race_lvl(wc_steamid,1)
			wc_clevel = get_race_lvl(wc_steamid)
		while get_xp_limit(wc_clevel - 1) > wc_users[wc_steamid][wc_race]['xp'] and wc_clevel >= 1:
			add_race_lvl(wc_steamid,-1)
			wc_clevel = get_race_lvl(wc_steamid)

# initializes players to their last race used when they join a team
def init_player(wc_userid):
	global wc_users
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_steamid == 'BOT' or wc_steamid == None or wc_steamid == 'STEAM_ID_PENDING':
		return 0
	if wc_users.has_key(wc_steamid):
		set_in_db(wc_steamid)
	else:
		# set player in temporary users list
		get_from_db(wc_steamid)
	#setup extra stuff
	wc_race = wc_skills[wc_steamid]['lastrace']
	wc_users[wc_steamid]['race'] = wc_race
	wc_users[wc_steamid]['object'] = wc_races_list[wc_race]['instance'](wc_userid)
	# handle the items
	if not wc_users[wc_steamid].has_key('items'):
		wc_users[wc_steamid]['items'] = {}
		i = 1
		while i <= wc_item_menus:
			wc_users[wc_steamid]['items'][i] = {}
			i += 1
	#setup common stuff
	wc_users[wc_steamid]['mole'] = 0
	wc_users[wc_steamid]['spawned'] = 0
	setup_player(wc_userid)

# sets up new players to the server when they join a team
def create_new_player(wc_userid):
	global wc_skills
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_steamid == 'BOT':
		return 0
	# create db entries
	wc_skills[wc_steamid] = {}
	for wc_racename in wc_racelist:
		wc_tmp2 = '0.0'
		for wc_tmpskill in wc_races_list[wc_racename]['skills']:
			wc_tmp2 += '.0'
		wc_skills[wc_steamid][wc_racename] = wc_tmp2
	wc_skills[wc_steamid]['lastrace'] = 'Undead Scourge'
	wc_skills[wc_steamid]['lastplayed'] = 0
	# setup the rest normally as if they already existed, because they do now!
	init_player(wc_userid)

# sets a players skills, used for player_spawn
def spawn_items(wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	if len(wc_users[wc_steamid]['items']) > 0:
		for wc_tmp in wc_users[wc_steamid]['items']:
			if len(wc_users[wc_steamid]['items'][wc_tmp]) > 0:
				for wc_tmp2 in wc_users[wc_steamid]['items'][wc_tmp].keys():
					wc_users[wc_steamid]['items'][wc_tmp][wc_tmp2]['object'].player_passive(wc_tmp)

# checks if the player is able to use ultimate
def regeneration():
	#es.msg('#green','Checking regen at cycle: ' + str(wc_regen_cycle))
	if len(wc_users) > 0:
		for wc_tmp in wc_users:
			if wc_users[wc_tmp]['rings'] > 0:
				wc_tmpuid = es.getuserid(wc_tmp)
				if wc_tmpuid != 0:
					if not int(es.getplayerprop(wc_tmpuid,"CBasePlayer.pl.deadflag")):
						wc_team = int(es.getplayerteam(wc_tmpuid))
						wc_tmpvector = vecmath.vector(es.getplayerlocation(wc_tmpuid))
						wc_nearlist = near_coord(wc_team,500,wc_tmpvector)
						if wc_nearlist != 0:
							for wc_listtmp in wc_nearlist:
								wc_tmpplayer = playerlib.getPlayer(wc_listtmp)
								wc_tmphealth = int(wc_tmpplayer.get('health'))
								wc_tmphealth += wc_users[wc_tmp]['rings']
								wc_tmpsid = es.getplayersteamid(wc_listtmp)
								if wc_tmpsid != 'BOT':
									if wc_tmphealth <= wc_users[wc_tmpsid]['maxhp']:
										wc_tmpplayer.set('health',wc_tmphealth)
									else:
										wc_tmpplayer.set('health',wc_users[wc_tmpsid]['maxhp'])
								else:
									if wc_tmphealth <= 100:
										wc_tmpplayer.set('health',wc_tmphealth)
									else:
										wc_tmpplayer.set('health',100)
	gamethread.delayed(2.0,regeneration,)
			
def regen_nades():
	if len(wc_nadelist) > 0:
		for wc_tmp in wc_nadelist:
			if es.getuserid(wc_tmp) != 0:
				wc_tmpme = playerlib.getPlayer(wc_tmp)
				if wc_tmpme.get('he') == 0:
					es.server.queuecmd('es_give ' + str(wc_tmp) + ' weapon_hegrenade')
	gamethread.delayed(wc_glove_timer,regen_nades,)
			
def wards_loop():
	if len(wc_wardlist) > 0:
		for wc_tmp in wc_wardlist:
			for wc_wardname in wc_wardlist[wc_tmp]:
				es.server.queuecmd(wc_wardlist[wc_tmp][wc_wardname]['effect'])
	gamethread.delayed(1.7,wards_loop,)
			
def move_moles():
	global wc_ctspawn, wc_tspawn, wc_moles, wc_timers
	if wc_timers.has_key('move_moles'):
		del wc_timers['move_moles']
		if len(wc_moles) > 0:
			for wc_tmp in wc_moles.keys():
				wc_steamid = es.getplayersteamid(wc_tmp)
				if wc_moles[wc_tmp] == 2:
					if len(wc_ctspawn) > 0:
						if wc_users[wc_steamid]['race'] == 'Orcish Horde':
							wc_tmpplayer = playerlib.getPlayer(wc_tmp)
							if wc_tmpplayer.get('he') == 1:
								es.server.queuecmd('est_removeweapon ' + str(wc_tmp) + ' weapon_hegrenade')
						wc_tmplist = wc_ctspawn.keys()
						random.shuffle(wc_tmplist)
						wc_tmpkey = wc_tmplist.pop()
						wc_xyz = es.splitvectorstring(wc_ctspawn[wc_tmpkey]["CBaseEntity.m_vecOrigin"])
						es.setpos(wc_tmp,wc_xyz[0],wc_xyz[1],wc_xyz[2])
						del wc_ctspawn[wc_tmpkey]
						disguiser(wc_tmp)
					else:
						es.tell(wc_tmp,'#green','Not enough room to mole.')
				else:
					if len(wc_tspawn) > 0:
						if wc_users[wc_steamid]['race'] == 'Orcish Horde':
							wc_tmpplayer = playerlib.getPlayer(wc_tmp)
							if wc_tmpplayer.get('he') == 1:
								es.server.queuecmd('est_removeweapon ' + str(wc_tmp) + ' weapon_hegrenade')
						wc_tmplist = wc_tspawn.keys()
						random.shuffle(wc_tmplist)
						wc_tmpkey = wc_tmplist.pop()
						wc_xyz = es.splitvectorstring(wc_tspawn[wc_tmpkey]["CBaseEntity.m_vecOrigin"])
						es.setpos(wc_tmp,wc_xyz[0],wc_xyz[1],wc_xyz[2])
						del wc_tspawn[wc_tmpkey]
						disguiser(wc_tmp)
					else:
						es.tell(wc_tmp,'#green','Not enough room to mole.')
		wc_moles = {}
					
def disguiser(wc_userid):
	wc_team = es.getplayerteam(wc_userid)
	if wc_team == 2:
		wc_tmplist = playerlib.getUseridList('#ct')
	else:
		wc_tmplist = playerlib.getUseridList('#t')
	wc_total = len(wc_tmplist)
	if wc_total > 0:
		random.shuffle(wc_tmplist)
		wc_stop = 0
		while wc_stop == 0 and len(wc_tmplist) > 0:
			wc_tmp = wc_tmplist.pop()
			wc_tmpid = es.getplayersteamid(wc_tmp)
			if wc_tmpid != 'BOT':
				if check_hasitem(wc_tmp,'Chameleon') == 0 and wc_users[wc_tmpid]['mole'] == 0:
					wc_stop = 1
			else:
				wc_stop = 1
		if wc_stop == 1:
			wc_skin = es.getplayerprop(wc_tmp,"CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_nModelIndex")
			es.setplayerprop(wc_userid,"CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_nModelIndex",wc_skin)
		else:
			es.tell(wc_userid,'#green','Disguise Failed')
		
def check_ultimate(wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_ult_enabled and wc_users[wc_steamid]['ultimate']:
		return wc_users[wc_steamid]['ultimate']
	else:
		return 0
		
def near_coord(wc_team,wc_distance,wc_vector):
	if wc_team == 3:
		wc_tmplist = playerlib.getUseridList('#ct,#alive')
	elif wc_team == 2:
		wc_tmplist = playerlib.getUseridList('#t,#alive')
	else:
		return 0
	wc_nearlist = []
	for wc_tmpuser in wc_tmplist:
		wc_steamid = es.getplayersteamid(wc_tmpuser)
		wc_tmpvector = vecmath.vector(es.getplayerlocation(wc_tmpuser))
		wc_tmpdistance = vecmath.distance(wc_vector,wc_tmpvector)
		if wc_tmpdistance <= wc_distance:
			wc_nearlist.append(str(wc_tmpuser))
	if len(wc_nearlist) > 0:
		return wc_nearlist
	else:
		return 0

# this takes a userid for team reference, the vector tells it where to look from
# this is done so we can check the teleport destination
# we could take the userid out and just use a team or a filter instead
# but then we have to determine it in the main code anyways
def check_blinkcoord(wc_userid,wc_vector):
	global wc_users
	wc_team = es.getplayerteam(wc_userid)
	if wc_team == 2:
		wc_tmplist = playerlib.getUseridList('#ct,#alive,#human')
	elif wc_team == 3:
		wc_tmplist = playerlib.getUseridList('#t,#alive,#human')
	else:
		return 1
	if len(wc_tmplist) > 0:
		for wc_tmpuser in wc_tmplist:
			wc_steamid = es.getplayersteamid(wc_tmpuser)
			if wc_users.has_key(wc_steamid):
				if wc_users[wc_steamid]['blink'] > 0:
					wc_tmpvector = vecmath.vector(es.getplayerlocation(wc_tmpuser))
					wc_tmpdistance = vecmath.distance(wc_vector,wc_tmpvector)
					if wc_tmpdistance <= wc_blinkdistance:
						wc_users[wc_steamid]['blink'] -= 1
						if wc_users[wc_steamid]['blink'] > 0:
							es.server.queuecmd('est_fade ' + str(wc_tmpuser) + ' 0 0.5 0 255 0 0 126')
						else:
							es.server.queuecmd('est_fade ' + str(wc_tmpuser) + ' 0 0.5 0 255 0 0 255')
							es.tell(wc_tmpuser,'#green','No Blink Charges Left')
						return int(wc_tmpuser)
	return 0

# checks the target to see if they can block the ultimate
# this doesn't really do any kind of real testing because
# it's assumed that you have already determined them as a valid target
def check_blink(wc_userid):
	wc_steamid = es.getplayersteamid(int(wc_userid))
	if wc_steamid != 'BOT' and wc_users.has_key(wc_steamid):
		if wc_users[wc_steamid]['blink'] > 0:
			wc_users[wc_steamid]['blink'] -= 1
			if wc_users[wc_steamid]['blink'] > 0:
				es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 255 0 0 126')
			else:
				es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 255 0 0 255')
				es.tell(wc_userid,'#green','No Blink Charges Left')
			return 1
	return 0
		
def wc_enable_ult(wc_userid):
	global wc_timers, wc_users
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_timers.has_key('ult' + str(wc_userid)):
		del wc_timers['ult' + str(wc_userid)]
		if wc_steamid != None:
			if wc_users.has_key(wc_steamid):
				wc_users[wc_steamid]['ultimate'] = 1
				es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Enabled')

# uses the ultimate
def use_ultimate():
	global wc_users, wc_timers
	wc_userid = es.getcmduserid()
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_userid > 0 and wc_steamid != None:
		wc_tmp = playerlib.getPlayer(wc_userid)
		if wc_users.has_key(wc_steamid):
			if wc_ult_enabled:
				if int(wc_tmp.get('isdead')) == 0:
					if wc_users[wc_steamid]['ultimate'] > 0:
						wc_users[wc_steamid]['ultimate'] = 0
						if wc_users[wc_steamid]['object'].ult_viewtarget:
							#userid in crosshairs
							wc_blinkcheck = check_blinkcoord(wc_userid, vecmath.vector(es.getplayerlocation(wc_userid)))
							if wc_blinkcheck == 0:
								es.server.queuecmd('est_GetViewPlayer ' + str(wc_userid) + ' wc_victim')
								gamethread.delayed(0.05,ult_viewtarget,wc_userid)
							else:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(wc_blinkcheck))
								es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
								es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 0 0 0 126')
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
						elif wc_users[wc_steamid]['object'].ult_target:
							#random target userid
							if int(es.getplayerteam(wc_userid)) == 2:
								wc_tmplist = playerlib.getUseridList('#ct,#alive')
							else:
								wc_tmplist = playerlib.getUseridList('#t,#alive')
							random.shuffle(wc_tmplist)
							wc_victim = wc_tmplist.pop()
							wc_blinkcheck = check_blink(wc_victim)
							if wc_blinkcheck == 0:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' on ' + es.getplayername(wc_victim))
								wc_users[wc_steamid]['object'].ultimate(int(wc_victim))
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
							else:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(str(wc_victim)))
								es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
						elif wc_users[wc_steamid]['object'].ult_coord:
							#target co-ordinates
							wc_blinkcheck = check_blinkcoord(wc_userid, vecmath.vector(es.getplayerlocation(wc_userid)))
							if wc_blinkcheck == 0:
								es.server.queuecmd('est_GetViewCoord ' + str(wc_userid) + ' wc_x wc_y wc_z')
								gamethread.delayed(0.05,ult_coord,wc_userid)
							else:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(wc_blinkcheck))
								es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
								es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 0 0 0 126')
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
						elif wc_users[wc_steamid]['object'].ult_skill:
							#target self
							wc_blinkcheck = check_blinkcoord(wc_userid, vecmath.vector(es.getplayerlocation(wc_userid)))
							if wc_blinkcheck == 0:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid))
								wc_users[wc_steamid]['object'].ultimate(int(wc_userid))
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
							else:
								#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(wc_blinkcheck))
								es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
								es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 0 0 0 126')
								wc_timers['ult' + str(wc_userid)] = wc_steamid
								gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
						else:
							es.server.queuecmd('est_csay ' + str(wc_userid) + ' Nothing to Activate.')
					elif wc_users[wc_steamid]['ultimate'] == 0:
						es.tell(wc_userid,'#green','Cannot activate, cooling down.')
					else:
						es.tell(wc_userid,'#green','You do not have an ultimate yet.')
				else:
					es.tell(wc_userid,'#green','Cannot activate while dead.')
			else:
				es.tell(wc_userid,'#green','Ultimates not active yet.')

def ult_coord(wc_userid):
	global wc_users, wc_timers
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_x = es.getString('wc_x')
	wc_y = es.getString('wc_y')
	wc_z = es.getString('wc_z')
	wc_vecstr = '%s,%s,%s' % (wc_x, wc_y, wc_z)
	wc_vector = vecmath.vector(wc_vecstr)
	wc_blinkcheck = check_blinkcoord(wc_userid, wc_vector)
	if wc_blinkcheck == 0:
		#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid))
		wc_users[wc_steamid]['object'].ultimate(wc_vector)
		wc_timers['ult' + str(wc_userid)] = wc_steamid
		gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
	else:
		#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(wc_blinkcheck))
		es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
		es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 0 0 0 126')
		wc_timers['ult' + str(wc_userid)] = wc_steamid
		gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
				
def ult_viewtarget(wc_userid):
	global wc_users, wc_timers
	wc_steamid = es.getplayersteamid(wc_userid)
	wc_victim = es.getString('wc_victim')
	#es.msg('#lightgreen',str(wc_victim))
	if str(wc_victim) == '0':
		#es.msg('#green','No target. ' + str(wc_userid) + ' ' + str(wc_victim))
		es.server.queuecmd('est_csay ' + str(wc_userid) + ' No Target in Crosshairs')
		wc_users[wc_steamid]['ultimate'] = 1
		return 0
	else:
		if es.getplayerteam(str(wc_victim)) != es.getplayerteam(wc_userid):
			wc_blinkcheck = check_blink(str(wc_victim))
			if wc_blinkcheck == 0:
				#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' on ' + es.getplayername(str(wc_victim)))
				wc_users[wc_steamid]['object'].ultimate(str(wc_victim))
				wc_timers['ult' + str(wc_userid)] = wc_steamid
				gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
			else:
				#es.msg('#lightgreen','!ultimate command used by ' + es.getplayername(wc_userid) + ' blocked by ' + es.getplayername(str(wc_victim)))
				es.server.queuecmd('est_csay ' + str(wc_userid) + ' Ultimate Blocked!')
				es.server.queuecmd('est_fade ' + str(wc_userid) + ' 0 0.5 0 0 0 0 126')
				wc_timers['ult' + str(wc_userid)] = wc_steamid
				gamethread.delayedname(wc_ult_cooldown,'ult' + str(wc_userid),wc_enable_ult,wc_userid)
		else:
			#es.msg('#green','Wrong Team. ' + str(wc_userid) + ' ' + str(wc_victim))
			es.server.queuecmd('est_csay ' + str(wc_userid) + ' Wrong Team')
			wc_users[wc_steamid]['ultimate'] = 1
				
def use_ability():
	global wc_users
	wc_userid = es.getcmduserid()
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_userid > 0 and wc_steamid != None:
		if wc_users.has_key(wc_steamid):
			if wc_users[wc_steamid]['ability'] > 0:
				if wc_users[wc_steamid]['disabled'] == 0:
					wc_users[wc_steamid]['ability'] -= 1
					wc_users[wc_steamid]['object'].ability()
				else:
					es.tell(wc_userid,'#green','Skills disabled')
			else:
				es.tell(wc_userid,'#green','You do not have an ability')
		
# activates the ultimate so its ready for use
def wc_ultimate_activate(wc_flag=1):
	global wc_ult_enabled, wc_timers
	if wc_timers.has_key('ult_activate'):
		del wc_timers['ult_activate']
		wc_ult_enabled = int(wc_flag)
		es.server.queuecmd('est_csay #a!b Ultimates Active!')

# stops remaining timers at round_end
def stop_timers(wc_steamid='0'):
	if wc_steamid == '0':
		for wc_tmp in wc_timers.keys():
			gamethread.cancelDelayed(wc_tmp)
			del wc_timers[wc_tmp]
	else:
		for wc_tmp in wc_timers.keys():
			if wc_timers[wc_tmp] == wc_steamid:
				gamethread.cancelDelayed(wc_tmp)
				del wc_timers[wc_tmp]

# checks if the player has a helm of excellence
def check_helm(wc_userid):
	return check_hasitem(wc_userid,'Helm of Excellence')

# checks which shopmenu item they have in specified slot, 0=none
def check_hasitem(wc_userid,wc_item,wc_type="name",wc_event="None"):
	wc_steamid = es.getplayersteamid(wc_userid)
	for i in wc_users[wc_steamid]['items']:
		if wc_users[wc_steamid]['items'][i].has_key(wc_item):
			if wc_type == 'name':
				return i
			elif wc_type == 'event':
				if wc_event in wc_users[wc_steamid]['items'][i][wc_item]['events']:
					return i
	return 0
	
def check_items(wc_event,wc_eventvars,wc_userid):
	wc_steamid = es.getplayersteamid(wc_userid)
	for wc_slot in wc_users[wc_steamid]['items'].keys():
		if len(wc_users[wc_steamid]['items'][wc_slot].keys()) > 0:
			for wc_itemname in wc_users[wc_steamid]['items'][wc_slot].keys():
				if wc_event in wc_users[wc_steamid]['items'][wc_slot][wc_itemname]['events']:
					wc_users[wc_steamid]['items'][wc_slot][wc_itemname]['object'].event_handle(wc_event,wc_eventvars,wc_slot)

# Temporary DB read/write functions:
def get_from_db(wc_steamid):
	global wc_users, wc_skills
	if wc_users.has_key(wc_steamid) or wc_steamid == 'BOT' or wc_steamid == 'STEAM_ID_PENDING':
		return 0
	else:
		wc_users[wc_steamid] = {}
	for wc_tmp3 in wc_races_list:
		if not wc_skills[wc_steamid].has_key(wc_tmp3):
			wc_tmp2 = '0.0'
			for wc_tmpskill in wc_races_list[wc_tmp3]['skills']:
				wc_tmp2 += '.0'
			wc_skills[wc_steamid][wc_tmp3] = wc_tmp2
			wc_users[wc_steamid]['race'] = 'Undead Scourge'
		else:
			wc_users[wc_steamid]['race'] = wc_skills[wc_steamid]['lastrace']
		wc_tmp = wc_skills[wc_steamid][wc_tmp3]
		wc_tmprace = wc_tmp.split(".")
		wc_users[wc_steamid][wc_tmp3] = {}
		i = 0
		for wc_tmpskill in wc_races_list[wc_tmp3]['skills']:
			wc_users[wc_steamid][wc_tmp3][wc_tmpskill] = int(wc_tmprace[i])
			i += 1
		wc_users[wc_steamid][wc_tmp3]['level'] = int(wc_tmprace[i])
		i += 1
		wc_users[wc_steamid][wc_tmp3]['xp'] = int(wc_tmprace[i])
	
def set_in_db(wc_steamid):
	global wc_skills
	if wc_steamid == 'BOT' or wc_steamid == None:
		return 0
	for wc_tmp2 in wc_races_list:
		wc_tmp = []
		if wc_skills.has_key(wc_steamid):
			for wc_tmpskill in wc_races_list[wc_tmp2]['skills']:
				#es.msg('#green','Saving: ' + wc_steamid + ' ' + wc_tmp2 + ' ' + wc_tmpskill)
				wc_tmp.append(str(wc_users[wc_steamid][wc_tmp2][wc_tmpskill]))
			wc_tmp.append(str(wc_users[wc_steamid][wc_tmp2]['level']))
			wc_tmp.append(str(wc_users[wc_steamid][wc_tmp2]['xp']))
			wc_tmp3 = ".".join(wc_tmp)
			wc_skills[wc_steamid][wc_tmp2] = wc_tmp3
			wc_skills[wc_steamid]['lastrace'] = wc_users[wc_steamid]['race']
			wc_skills[wc_steamid]['lastplayed'] = time.gmtime()[7]
		
# gets users race from the temporary list
def get_race(wc_steamid):
	if wc_users.has_key(wc_steamid):
		return wc_users[wc_steamid]['race']
	else:
		return '0'

def set_race(wc_userid,wc_race):
	global wc_users
	#es.msg('#green','Setting race to: ' + wc_race)
	wc_steamid = es.getplayersteamid(wc_userid)
	if wc_races_list.has_key(wc_race) and wc_users.has_key(wc_steamid):
		wc_users[wc_steamid]['race'] = wc_race
		wc_users[wc_steamid]['object'] = wc_races_list[wc_race]['instance'](wc_userid)
	for wc_slot in wc_users[wc_steamid]['items']:
		for wc_item in wc_users[wc_steamid]['items'][wc_slot]:
			wc_users[wc_steamid]['items'][wc_slot][wc_item]['object'].drop_item()
	i = 1
	while i <= wc_item_menus:
		wc_users[wc_steamid]['items'][i] = {}
		i += 1
	show_users_xp(wc_userid)

def get_race_lvl(wc_steamid,wc_race='0'):
	if wc_race == '0':
		wc_race = get_race(wc_steamid)
	return wc_users[wc_steamid][wc_race]['level']

def set_race_lvl(wc_steamid,wc_level,wc_race='0'):
	global wc_users
	if wc_race == '0':
		wc_race = get_race(wc_steamid)
	if wc_users.has_key(wc_steamid):
		wc_users[wc_steamid][wc_race]['level'] = wc_level
		wc_users[wc_steamid]['object'] = wc_races_list[wc_race]['instance'](es.getuserid(wc_steamid))

def get_skill_lvl(wc_steamid,wc_skill):
	if wc_users.has_key(wc_steamid):
		wc_tmprace = wc_users[wc_steamid]['race']
		if wc_users[wc_steamid][wc_tmprace].has_key(wc_skill):
			return wc_users[wc_steamid][wc_tmprace][wc_skill]
		else:
			return 0
	else:
		return 0

def set_skill_lvl(wc_steamid,wc_skill,wc_value):
	global wc_users
	if wc_users.has_key(wc_steamid):
		wc_tmprace = wc_users[wc_steamid]['race']
		wc_users[wc_steamid][wc_tmprace][wc_skill] = wc_value
		wc_users[wc_steamid]['object'].refresh_skills()

def reset_skills(wc_steamid):
	wc_race = wc_users[wc_steamid]['race']
	for wc_tmp in wc_races_list[wc_race]['skills']:
		set_skill_lvl(wc_steamid,wc_tmp,0)
	wc_users[wc_steamid]['object'].refresh_skills()
		
def get_users_xp(wc_steamid,wc_race='0'):
	if wc_race == '0':
		wc_race = get_race(wc_steamid)
	return wc_users[wc_steamid][wc_race]['xp']
	
def show_users_xp(wc_userid):
	wc_steamid = es.getplayersteamid(int(wc_userid))
	wc_race_lvl = get_race_lvl(wc_steamid)
	wc_current_xp = get_users_xp(wc_steamid)
	wc_limit = get_xp_limit(wc_race_lvl)
	es.tell(wc_userid,'#multi','#lightgreen[ #green' + get_race(wc_steamid) + ' #lightgreenLevel #green' + str(wc_race_lvl) + ' #lightgreen]')
	es.tell(wc_userid,'#multi','#lightgreen[ #green' + str(wc_current_xp) + ' #lightgreen/ #green ' + str(wc_limit) + ' #lightgreen]')

def set_users_xp(wc_steamid,wc_ammount,wc_race='0'):
	global wc_users
	if wc_race == '0':
		wc_race = get_race(wc_steamid)
	wc_users[wc_steamid][wc_race]['xp'] = wc_ammount

def get_xp_limit(wc_race_lvl):
	if wc_race_lvl >= wc_max_lvl:
		return 9999999
	else:
		return int((wc_lvl_exponent ** wc_race_lvl) * wc_lvl_mod)
	
# add/subtract xp from current race
def add_users_xp(wc_steamid,wc_ammount):
	wc_tmpxp = get_users_xp(wc_steamid)
	wc_tmpxp += wc_ammount
	if wc_tmpxp < 0:
		wc_tmpxp = 0
	set_users_xp(wc_steamid,wc_tmpxp)

# add/subtract skill lvls from current race
def add_skill_lvl(wc_steamid,wc_skill,wc_ammount):
	wc_tmpskill = get_skill_lvl(wc_steamid,wc_skill)
	wc_tmpskill += wc_ammount
	if wc_tmpskill < 0:
		wc_tmpskill = 0
	elif wc_tmpskill > wc_max_skill_lvl:
		if wc_races_list[wc_users[wc_steamid]['race']]['skills'][wc_skill] == 'skill' or wc_races_list[wc_users[wc_steamid]['race']]['skills'][wc_skill] == 'ability':
			wc_tmpskill = wc_max_skill_lvl
	elif wc_tmpskill > wc_max_ult_lvl and wc_races_list[wc_users[wc_steamid]['race']]['skills'][wc_skill] == 'ult':
		wc_tmpskill = wc_max_ult_lvl
	set_skill_lvl(wc_steamid,wc_skill,wc_tmpskill)

def add_race_lvl(wc_steamid,wc_ammount,wc_race='0'):
	if wc_race == '0':
		wc_race = get_race(wc_steamid)
	wc_tmplvl = get_race_lvl(wc_steamid,wc_race)
	wc_tmplvl += wc_ammount
	if wc_tmplvl < 0:
		wc_tmplvl = 0
	elif wc_tmplvl > wc_max_race_lvl:
		wc_tmplvl = wc_max_race_lvl
	set_race_lvl(wc_steamid,wc_tmplvl,wc_race)
	wc_userid = es.getuserid(wc_steamid)
	if wc_ammount < 0:
		reset_skills(wc_steamid)
	wc_Skill_Menu(wc_userid)
		
